%Created by Ryan J. Smith for SpinCore Technologies 2007

function varargout = spincore_snr_gui(varargin)
% SPINCORE_SNR_GUI M-file for spincore_snr_gui.fig
%      SPINCORE_SNR_GUI, by itself, creates a new SPINCORE_SNR_GUI or raises the existing
%      singleton*.
%
%      H = SPINCORE_SNR_GUI returns the handle to a new SPINCORE_SNR_GUI or the handle to
%      the existing singleton*.
%
%      SPINCORE_SNR_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SPINCORE_SNR_GUI.M with the given input arguments.
%
%      SPINCORE_SNR_GUI('Property','Value',...) creates a new SPINCORE_SNR_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before spincore_snr_gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to spincore_snr_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help spincore_snr_gui

% Last Modified by GUIDE v2.5 18-May-2007 13:09:03

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @spincore_snr_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @spincore_snr_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before spincore_snr_gui is made visible.
function spincore_snr_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to spincore_snr_gui (see VARARGIN)

% Choose default command line output for spincore_snr_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes spincore_snr_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);
hold off

setappdata(0, 'hSnrGui', gcf);
setappdata(gcf, 'selectFlag', 0);

hParentGui = getappdata(0, 'hParentGui');

freqValues = getappdata(hParentGui, 'freqValues');
compPsd = getappdata(hParentGui,'compPsd');

set(handles.butSnr, 'enable', 'off');
set(handles.panelSnr, 'visible', 'off');

semilogy(freqValues,compPsd);
set(gca, 'XDir', 'reverse');
xlabel('Frequency (kHz)');
ylabel('Amplitude');
title('FFT, Semi-Log Scale');
axis tight;

% --- Outputs from this function are returned to the command line.
function varargout = spincore_snr_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%---------------------------------------------------------
function butSelect_Callback(hObject, eventdata, handles)
%---------------------------------------------------------

set(handles.butSnr, 'enable', 'off');
set(handles.panelSnr,'visible','off');

hParentGui = getappdata(0, 'hParentGui');
hSnrGui = getappdata(0, 'hSnrGui');

freqValues = getappdata(hParentGui, 'freqValues');
compPsd = getappdata(hParentGui,'compPsd');

hold off;
axes(handles.axes1);
semilogy(freqValues, compPsd);
set(gca, 'XDir', 'reverse');
xlabel('Frequency (kHz)');
ylabel('Amplitude');
title('FFT, Semi-Log Scale');
axis tight;

hold on;

ylims = get(gca,'ylim');

set(handles.editStatus,'String','Click to set bounds of signal portion of plot');
drawnow;

for n = 1:2
[xSig(n),ySig(n)]=ginput(1);
plot([xSig(n),xSig(n)],ylims,'g');
drawnow;
end

%Rearrange selected points so that leftmost point is stored in x(1)
if  (xSig(1) > xSig(2))
    temp = xSig(1);
    xSig(1) = xSig(2);
    xSig(2) = temp;
end

%Find corresponding index for selected points
index1 = find(freqValues < (xSig(1) + freqValues(2)-freqValues(1)),1,'last');
index2 = find(freqValues < (xSig(2) + freqValues(2)-freqValues(1)),1,'last');

%Highlight selected portion of the plot in red
semilogy(freqValues(index1:index2),compPsd(index1:index2),'g');
drawnow;

set(handles.editStatus, 'String', 'Click to set bounds of noise portion of plot');
drawnow;

for n = 1:2
[xNoise(n),yNoise(n)]=ginput(1);
plot([xNoise(n),xNoise(n)],ylims,'r');
end

if  (xNoise(1) > xNoise(2))
    temp = xNoise(1);
    xNoise(1) = xNoise(2);
    xNoise(2) = temp;
end

index3 = find(freqValues < (xNoise(1) + freqValues(2)-freqValues(1)),1,'last');
index4 = find(freqValues < (xNoise(2) + freqValues(2)-freqValues(1)),1,'last');

semilogy(freqValues(index3:index4),compPsd(index3:index4),'r');
drawnow;

set(handles.editStatus, 'String', 'Ready');

setappdata(hSnrGui,     'index1', index1);
setappdata(hSnrGui,     'index2', index2);
setappdata(hSnrGui,     'index3', index3);
setappdata(hSnrGui,     'index4', index4);
setappdata(hSnrGui, 'selectFlag', 1);

set(handles.butSnr, 'enable', 'on');

%------------------------------------------------------
function butSnr_Callback(hObject, eventdata, handles)
%------------------------------------------------------

hSnrGui = getappdata(0, 'hSnrGui');
hParentGui = getappdata(0, 'hParentGui');
selectFlag = getappdata(hSnrGui, 'selectFlag');
index1 = getappdata(hSnrGui, 'index1');
index2 = getappdata(hSnrGui, 'index2');
index3 = getappdata(hSnrGui, 'index3');
index4 = getappdata(hSnrGui, 'index4');
compPsd = getappdata(hParentGui, 'compPsd');

if selectFlag == 1
    %signalRms = sqrt((sum(compPsd(index1:index2).^2))/(index2-index1));
    
    signalRms = max(compPsd(index1:index2));
    noiseRms = sqrt((sum(compPsd(index3:index4).^2))/(index4-index3));
    snr = signalRms/noiseRms;
    
    set(handles.editSigRms, 'string', signalRms);
    set(handles.editNoiseRms, 'string', noiseRms);
    set(handles.editSnr, 'string', snr);
    
    set(handles.panelSnr,'visible','on');
    
    setappdata(hSnrGui, 'snr', snr);
    setappdata(hSnrGui, 'noiseRms', noiseRms);
    setappdata(hSnrGui, 'signalRms', signalRms);
else
    set(editStatus,'String','Error: No data selected.');    
end

%----------------------------------------------------------
function editStatus_Callback(hObject, eventdata, handles)
%----------------------------------------------------------

%-----------------------------------------------------------
function editStatus_CreateFcn(hObject, eventdata, handles)
%-----------------------------------------------------------

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String','Ready');


function editSigRms_Callback(hObject, eventdata, handles)


function editSigRms_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editNoiseRms_Callback(hObject, eventdata, handles)


function editNoiseRms_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function editSnr_Callback(hObject, eventdata, handles)


function editSnr_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


