/*************************************************************************
 * Probes the board to get status and current number of scans.  Prototype
 * is [status, scans] = pbReadStatus();
 *
 *************************************************************************/

#include "math.h"
#include "mex.h"
#include "spinapi.h"
#include "string.h"
#include "stdio.h"
#include "stdlib.h"
#define RAM_SIZE (16*1024)

void pbReadStatus(int status[], int scans[])
{

    pb_init();
        
	status[0]=pb_read_status();
    
    scans[0]=pb_scan_count(0);
    
    pb_close();
    
    return;
}

void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[])
{
    int *status;
    int *scans;
        
    plhs[0] = mxCreateNumericMatrix(1,1, mxINT32_CLASS, mxREAL);
    plhs[1] = mxCreateNumericMatrix(1,1, mxINT32_CLASS, mxREAL);
        
    status = (int*)mxGetPr(plhs[0]);
    scans = (int*)mxGetPr(plhs[1]);
    
    pbReadStatus(status, scans);
    
}
