function varargout = spincore_hahnecho_gui(varargin)
%Created By Song Kui for SpinCore Technologies 2017
%SPINCORE_HAHNECHO_GUI MATLAB code file for spincore_hahnecho_gui.fig
%      SPINCORE_HAHNECHO_GUI, by itself, creates a new SPINCORE_HAHNECHO_GUI or raises the existing
%      singleton*.
%
%      H = SPINCORE_HAHNECHO_GUI returns the handle to a new SPINCORE_HAHNECHO_GUI or the handle to
%      the existing singleton*.
%
%      SPINCORE_HAHNECHO_GUI('Property','Value',...) creates a new SPINCORE_HAHNECHO_GUI using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to spincore_hahnecho_gui_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      SPINCORE_HAHNECHO_GUI('CALLBACK') and SPINCORE_HAHNECHO_GUI('CALLBACK',hObject,...) call the
%      local function named CALLBACK in SPINCORE_HAHNECHO_GUI.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help spincore_hahnecho_gui

% Last Modified by GUIDE v2.5 02-Aug-2017 11:21:41
if (exist('./EssentialGuiFiles', 'dir') == 7)
addpath('./EssentialGuiFiles/');
end

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @spincore_hahnecho_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @spincore_hahnecho_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before spincore_hahnecho_gui is made visible.
function spincore_hahnecho_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for spincore_hahnecho_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);
set(handles.figure1,'CloseRequestFcn','closeGUI');
guidata(hObject, handles);
setappdata(0, 'hHahnecho', gcf);
hHahnecho = getappdata(0, 'hHahnecho');
set(handles.FILE_NAME,'string','hahn_echo');
set(handles.BOARD_NUMBER,'string','0');
set(handles.BLANK_BIT,'string','2');
set(handles.DEBUG,'value',0);
set(handles.ADC_FREQUENCY,'string','75.0');
set(handles.SPECTROMETER_FREQUENCY,'string','10.778');
set(handles.SPECTRAL_WIDTH,'string','25');
set(handles.AMPLITUDE,'string','1.0');
set(handles.PULSE90_TIME,'string','90');
set(handles.PULSE90_PHASE,'string', '182');
set(handles.PULSE180_TIME, 'string', '180');
set(handles.INCLUDE_90, 'value', 1);
set(handles.BYPASS_FIR, 'value', 1);
set(handles.NUMBER_OF_SCANS, 'string', '2');
set(handles.TAU, 'string', '5000');
set(handles.BLANKING_DELAY, 'string', '3.00');
set(handles.TRANS_DELAY, 'string', '150');
set(handles.REPETITION_DELAY, 'string', '1.0');
dataFlag = 0;
drawnow;




% UIWAIT makes spincore_hahnecho_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = spincore_hahnecho_gui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --- Executes on button press in scanButton.
function scanButton_Callback(hObject, eventdata, handles)
% hObject    handle to scanButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
hHahnecho= getappdata(0, 'hHahnecho');
error = 0;
set(handles.status,'String','Scan in Progress');
drawnow;



[FILE_NAME, BOARD_NUMBER, BLANK_BIT, DEBUG, ADC_FREQUENCY, SPECTROMETER_FREQUENCY,...
    SPECTRAL_WIDTH, AMPLITUDE, PULSE90_TIME, PULSE90_PHASE, PULSE180_TIME, INCLUDE_90,...
    BYPASS_FIR, NUMBER_OF_SCANS, TAU, BLANKING_DELAY, TRANS_DELAY, REPETITION_DELAY]...
    =pollInputParameters(handles);

errorChecking(FILE_NAME, BOARD_NUMBER, BLANK_BIT, DEBUG, ADC_FREQUENCY, SPECTROMETER_FREQUENCY,...
    SPECTRAL_WIDTH, AMPLITUDE, PULSE90_TIME, PULSE90_PHASE, PULSE180_TIME, INCLUDE_90,...
    BYPASS_FIR, NUMBER_OF_SCANS, TAU, BLANKING_DELAY, TRANS_DELAY, REPETITION_DELAY);



storeInputParameter (FILE_NAME, BOARD_NUMBER, BLANK_BIT, DEBUG, ADC_FREQUENCY,...
            SPECTROMETER_FREQUENCY, SPECTRAL_WIDTH, AMPLITUDE, PULSE90_TIME, PULSE90_PHASE,...
            PULSE180_TIME, INCLUDE_90, BYPASS_FIR, NUMBER_OF_SCANS,TAU, BLANKING_DELAY, TRANS_DELAY,...
            REPETITION_DELAY);
        

        
if exist('.\LogFiles') == 7
        cd('.\LogFiles');
        
        if exist(FILE_NAME) ~= 7
            mkdir(cd,FILE_NAME);
        end
        
        cd(FILE_NAME);
        addpath('..\..\EssentialGuiFiles');
        [realData,imagData, NUM_POINTS] = hahn_echo(FILE_NAME, BOARD_NUMBER, BLANK_BIT, DEBUG, ADC_FREQUENCY,...
            SPECTROMETER_FREQUENCY, SPECTRAL_WIDTH, AMPLITUDE, PULSE90_TIME, PULSE90_PHASE,...
            PULSE180_TIME, INCLUDE_90, BYPASS_FIR, NUMBER_OF_SCANS,TAU, BLANKING_DELAY, TRANS_DELAY,...
            REPETITION_DELAY);
        cd('..\..\');
    else
        cd('..\LogFiles');
        
        if exist(FILE_NAME) ~=7
        mkdir(cd,FILE_NAME);
        end
        
        cd(FILE_NAME);
        addpath('..\..\EssentialGuiFiles');
        [realData,imagData, NUM_POINTS] = hahn_echo(FILE_NAME, BOARD_NUMBER, BLANK_BIT, DEBUG, ADC_FREQUENCY,...
            SPECTROMETER_FREQUENCY, SPECTRAL_WIDTH, AMPLITUDE, PULSE90_TIME, PULSE90_PHASE,...
            PULSE180_TIME, INCLUDE_90, BYPASS_FIR, NUMBER_OF_SCANS,TAU, BLANKING_DELAY, TRANS_DELAY,...
            REPETITION_DELAY);
        cd('..\..\EssentialGuiFiles');
    end
        
        
        %{
        [realData,imagData, NUM_POINTS] = hahn_echo(FILE_NAME, BOARD_NUMBER, BLANK_BIT, DEBUG, ADC_FREQUENCY,...
            SPECTROMETER_FREQUENCY, SPECTRAL_WIDTH, AMPLITUDE, PULSE90_TIME, PULSE90_PHASE,...
            PULSE180_TIME, INCLUDE_90, BYPASS_FIR, NUMBER_OF_SCANS,TAU, BLANKING_DELAY, TRANS_DELAY,...
            REPETITION_DELAY);
        %}
        
set(handles.status,'String','DONE');
drawnow;



realData=double(realData(1:NUM_POINTS));%how many num points to be plotted
imagData=double(imagData(1:NUM_POINTS));
NUM_POINTS = double(NUM_POINTS);
timeValues = (1:NUM_POINTS)*(1/SPECTRAL_WIDTH);
assignin('base','timeValues',timeValues);
magData = zeros(1,NUM_POINTS);
n = 1:NUM_POINTS;
magData(n) = sqrt(realData(n).^2+imagData(n).^2);

assignin('base','realData',realData);
assignin('base','imagData',imagData);
assignin('base','NUM_POINTS',NUM_POINTS);


            

switch get(handles.timePanel,'SelectedObject')
                case handles.radioReal
                    axes(handles.axes1);
                    plotRealData(timeValues,realData);
                case handles.radioImag
                    axes(handles.axes1);
                    plotImagData(timeValues,imagData);
                case handles.radioMag
                    axes(handles.axes1);
                    plotMagData(timeValues,magData);
end

dataFlag = 1;

setappdata(hHahnecho,       'timeValues', timeValues);
setappdata(hHahnecho,         'realData', realData);
setappdata(hHahnecho,         'imagData', imagData);
setappdata(hHahnecho,          'magData', magData);
setappdata(hHahnecho,         'dataFlag', dataFlag);
setappdata(hHahnecho,         'NUM_POINTS', NUM_POINTS);
            



        
        


% --- Executes on button press in dataButton.
function dataButton_Callback(hObject, eventdata, handles)
% hObject    handle to dataButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function status_Callback(hObject, eventdata, handles)
% hObject    handle to status (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of status as text
%        str2double(get(hObject,'String')) returns contents of status as a double


% --- Executes during object creation, after setting all properties.
function status_CreateFcn(hObject, eventdata, handles)
% hObject    handle to status (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when selected object is changed in timePanel.
function timePanel_SelectionChangedFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in timePanel 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
hHahnecho= getappdata(0, 'hHahnecho');
realData = getappdata(hHahnecho, 'realData');
imagData = getappdata(hHahnecho, 'imagData');
magData = getappdata(hHahnecho, 'magData');
timeValues = getappdata(hHahnecho, 'timeValues');
dataFlag = getappdata(hHahnecho, 'dataFlag');

if dataFlag == 0
    set(handles.statusBox,'String','Error: No data acquired yet.');
    drawnow;    
    
elseif dataFlag ==1
    
    switch get(hObject,'Tag')   % Get Tag of selected object
        case 'radioReal'
            axes(handles.axes1);
            plotRealData(timeValues,realData);
        
        case 'radioImag'
            axes(handles.axes1);
            plotImagData(timeValues,imagData);
        
        case 'radioMag'
            axes(handles.axes1);
            plotMagData(timeValues,magData);
    end
end




% --- Executes on button press in stopButton.
function stopButton_Callback(hObject, eventdata, handles)
% hObject    handle to stopButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in SetToResonance.
function SetToResonance_Callback(hObject, eventdata, handles)
% hObject    handle to SetToResonance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[FILE_NAME, BOARD_NUMBER, BLANK_BIT, DEBUG, ADC_FREQUENCY, SPECTROMETER_FREQUENCY,...
    SPECTRAL_WIDTH, AMPLITUDE, PULSE90_TIME, PULSE90_PHASE, PULSE180_TIME, INCLUDE_90,...
    BYPASS_FIR, NUMBER_OF_SCANS, TAU, BLANKING_DELAY, TRANS_DELAY, REPETITION_DELAY]...
    =pollInputParameters(handles);
num_points = 8192;
if (SPECTRAL_WIDTH < 50)
        SPECTRAL_WIDTH = 500;
end
    
    set(handles.status,'String','Detecting Resonance Frequency');
    drawnow;
    
    SpnmrWithDelay(num_points, SPECTROMETER_FREQUENCY, SPECTRAL_WIDTH,PULSE180_TIME, TRANS_DELAY, REPETITION_DELAY,...
        NUMBER_OF_SCANS, PULSE90_PHASE+90, BYPASS_FIR, ADC_FREQUENCY, AMPLITUDE, BLANK_BIT, BLANKING_DELAY, 'hard');  

    [realRes, imagRes] = pbGetData();
    realRes = double(realRes);
    imagRes = double(imagRes);
    
for n = 1:num_points
        compRes(n) = realRes(n)+i*imagRes(n);
end
    
    compResFft = fft(compRes);
    [maxVal,index] = max(compResFft);
    if index > num_points/2
        offset = -1*(num_points-index+1)*SPECTRAL_WIDTH*(1/num_points)*(1/1000);
    else
        offset = SPECTRAL_WIDTH*(index-1)*(1/num_points)*(1/1000);
    end
    
    if index > num_points/2
        resSF = SPECTROMETER_FREQUENCY + offset;
    else
        resSF = SPECTROMETER_FREQUENCY + offset;
    end  
    set(handles.SPECTROMETER_FREQUENCY,'String',resSF);
    
    set(handles.status,'String','Ready');
    drawnow;





function FILE_NAME_Callback(hObject, eventdata, handles)
% hObject    handle to FILE_NAME (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FILE_NAME as text
%        str2double(get(hObject,'String')) returns contents of FILE_NAME as a double


% --- Executes during object creation, after setting all properties.
function FILE_NAME_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FILE_NAME (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function BOARD_NUMBER_Callback(hObject, eventdata, handles)
% hObject    handle to BOARD_NUMBER (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of BOARD_NUMBER as text
%        str2double(get(hObject,'String')) returns contents of BOARD_NUMBER as a double


% --- Executes during object creation, after setting all properties.
function BOARD_NUMBER_CreateFcn(hObject, eventdata, handles)
% hObject    handle to BOARD_NUMBER (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function BLANK_BIT_Callback(hObject, eventdata, handles)
% hObject    handle to BLANK_BIT (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of BLANK_BIT as text
%        str2double(get(hObject,'String')) returns contents of BLANK_BIT as a double


% --- Executes during object creation, after setting all properties.
function BLANK_BIT_CreateFcn(hObject, eventdata, handles)
% hObject    handle to BLANK_BIT (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ADC_FREQUENCY_Callback(hObject, eventdata, handles)
% hObject    handle to ADC_FREQUENCY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ADC_FREQUENCY as text
%        str2double(get(hObject,'String')) returns contents of ADC_FREQUENCY as a double


% --- Executes during object creation, after setting all properties.
function ADC_FREQUENCY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ADC_FREQUENCY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function SPECTROMETER_FREQUENCY_Callback(hObject, eventdata, handles)
% hObject    handle to SPECTROMETER_FREQUENCY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of SPECTROMETER_FREQUENCY as text
%        str2double(get(hObject,'String')) returns contents of SPECTROMETER_FREQUENCY as a double


% --- Executes during object creation, after setting all properties.
function SPECTROMETER_FREQUENCY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SPECTROMETER_FREQUENCY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function SPECTRAL_WIDTH_Callback(hObject, eventdata, handles)
% hObject    handle to SPECTRAL_WIDTH (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of SPECTRAL_WIDTH as text
%        str2double(get(hObject,'String')) returns contents of SPECTRAL_WIDTH as a double


% --- Executes during object creation, after setting all properties.
function SPECTRAL_WIDTH_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SPECTRAL_WIDTH (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function AMPLITUDE_Callback(hObject, eventdata, handles)
% hObject    handle to AMPLITUDE (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of AMPLITUDE as text
%        str2double(get(hObject,'String')) returns contents of AMPLITUDE as a double


% --- Executes during object creation, after setting all properties.
function AMPLITUDE_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AMPLITUDE (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function PULSE180_TIME_Callback(hObject, eventdata, handles)
% hObject    handle to PULSE180_TIME (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PULSE180_TIME as text
%        str2double(get(hObject,'String')) returns contents of PULSE180_TIME as a double


% --- Executes during object creation, after setting all properties.
function PULSE180_TIME_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PULSE180_TIME (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





% --- Executes on button press in BYPASS_FIR.
function BYPASS_FIR_Callback(hObject, eventdata, handles)
% hObject    handle to BYPASS_FIR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of BYPASS_FIR



function PULSE90_TIME_Callback(hObject, eventdata, handles)
% hObject    handle to PULSE90_TIME (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PULSE90_TIME as text
%        str2double(get(hObject,'String')) returns contents of PULSE90_TIME as a double


% --- Executes during object creation, after setting all properties.
function PULSE90_TIME_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PULSE90_TIME (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function PULSE90_PHASE_Callback(hObject, eventdata, handles)
% hObject    handle to PULSE90_PHASE (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PULSE90_PHASE as text
%        str2double(get(hObject,'String')) returns contents of PULSE90_PHASE as a double


% --- Executes during object creation, after setting all properties.
function PULSE90_PHASE_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PULSE90_PHASE (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end






function pulseBox1_Callback(hObject, eventdata, handles)
% hObject    handle to pulseBox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pulseBox1 as text
%        str2double(get(hObject,'String')) returns contents of pulseBox1 as a double


% --- Executes during object creation, after setting all properties.
function pulseBox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pulseBox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in NewPlot.
function NewPlot_Callback(hObject, eventdata, handles)
% hObject    handle to NewPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
hHahnecho= getappdata(0, 'hHahnecho');
realData = getappdata(hHahnecho, 'realData');
imagData = getappdata(hHahnecho, 'imagData');
magData = getappdata(hHahnecho, 'magData');
timeValues = getappdata(hHahnecho, 'timeValues');
dataFlag = getappdata(hHahnecho, 'dataFlag');

if get(handles.radioReal,'Value')==1
        figure;
        plotRealData(timeValues,realData);
    elseif get(handles.radioImag,'Value')==1
        figure;
        plotImagData(timeValues,imagData);
    elseif get(handles.radioMag,'Value')==1
        figure;
        plotMagData(timeValues,magData);
    end


% --------------------------------------------------------------------
function menuFile_Callback(hObject, eventdata, handles)
% hObject    handle to menuFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menuLoad_Callback(hObject, eventdata, handles)
% hObject    handle to menuLoad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menuSave_Callback(hObject, eventdata, handles)
% hObject    handle to menuSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

  
% --- Executes on button press in INCLUDE_90.
function INCLUDE_90_Callback(hObject, eventdata, handles)
% hObject    handle to INCLUDE_90 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of INCLUDE_90



function NUMBER_OF_SCANS_Callback(hObject, eventdata, handles)
% hObject    handle to NUMBER_OF_SCANS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NUMBER_OF_SCANS as text
%        str2double(get(hObject,'String')) returns contents of NUMBER_OF_SCANS as a double


% --- Executes during object creation, after setting all properties.
function NUMBER_OF_SCANS_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NUMBER_OF_SCANS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function TAU_Callback(hObject, eventdata, handles)
% hObject    handle to TAU (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of TAU as text
%        str2double(get(hObject,'String')) returns contents of TAU as a double


% --- Executes during object creation, after setting all properties.
function TAU_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TAU (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function BLANKING_DELAY_Callback(hObject, eventdata, handles)
% hObject    handle to BLANKING_DELAY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of BLANKING_DELAY as text
%        str2double(get(hObject,'String')) returns contents of BLANKING_DELAY as a double


% --- Executes during object creation, after setting all properties.
function BLANKING_DELAY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to BLANKING_DELAY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function TRANS_DELAY_Callback(hObject, eventdata, handles)
% hObject    handle to TRANS_DELAY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of TRANS_DELAY as text
%        str2double(get(hObject,'String')) returns contents of TRANS_DELAY as a double


% --- Executes during object creation, after setting all properties.
function TRANS_DELAY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TRANS_DELAY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function REPETITION_DELAY_Callback(hObject, eventdata, handles)
% hObject    handle to REPETITION_DELAY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of REPETITION_DELAY as text
%        str2double(get(hObject,'String')) returns contents of REPETITION_DELAY as a double


% --- Executes during object creation, after setting all properties.
function REPETITION_DELAY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to REPETITION_DELAY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

    function storeInputParameter (FILE_NAME, BOARD_NUMBER, BLANK_BIT, DEBUG, ADC_FREQUENCY,...
            SPECTROMETER_FREQUENCY, SPECTRAL_WIDTH, AMPLITUDE, PULSE90_TIME, PULSE90_PHASE,...
            PULSE180_TIME, INCLUDE_90, BYPASS_FIR, NUMBER_OF_SCANS,TAU, BLANKING_DELAY, TRANS_DELAY,...
            REPETITION_DELAY)
        hHahnecho = getappdata(0, 'hHahnecho');
        setappdata (hHahnecho, 'FILE_NAME', FILE_NAME);
        setappdata (hHahnecho, 'BOARD_NUMBER', BOARD_NUMBER);
        setappdata (hHahnecho, 'BLANK_BIT', BLANK_BIT);
        setappdata (hHahnecho, 'DEBUG', DEBUG);
        setappdata (hHahnecho, 'ADC_FREQUENCY', ADC_FREQUENCY);
        setappdata (hHahnecho, 'SPECTROMETER_FREQUENCY', SPECTROMETER_FREQUENCY);
        setappdata (hHahnecho, 'SPECTRAL_WIDTH', SPECTRAL_WIDTH);
        setappdata (hHahnecho, 'AMPLITUDE', AMPLITUDE);
        setappdata (hHahnecho, 'PULSE90_TIME', PULSE90_TIME);
        setappdata (hHahnecho, 'PULSE90_PHASE', PULSE90_PHASE);
        setappdata (hHahnecho, 'PULSE180_TIME', PULSE180_TIME);
        setappdata (hHahnecho, 'INCLUDE_90', INCLUDE_90);
        setappdata (hHahnecho, 'BYPASS_FIR', BYPASS_FIR);
        setappdata (hHahnecho, 'NUMBER_OF_SCANS', NUMBER_OF_SCANS);
        setappdata (hHahnecho, 'TAU', TAU);
        setappdata (hHahnecho, 'BLANKING_DELAY', BLANKING_DELAY);
        setappdata (hHahnecho, 'TRANS_DELAY', TRANS_DELAY);
        setappdata (hHahnecho, 'REPETITION_DELAY', REPETITION_DELAY);
        
        
  function [FILE_NAME, BOARD_NUMBER, BLANK_BIT, DEBUG, ADC_FREQUENCY, SPECTROMETER_FREQUENCY,...
    SPECTRAL_WIDTH, AMPLITUDE, PULSE90_TIME, PULSE90_PHASE, PULSE180_TIME, INCLUDE_90,...
    BYPASS_FIR, NUMBER_OF_SCANS, TAU, BLANKING_DELAY, TRANS_DELAY, REPETITION_DELAY]...
    =pollInputParameters(handles)

    FILE_NAME = get(handles.FILE_NAME,'String');
    BOARD_NUMBER = str2double(get(handles.BOARD_NUMBER,'String'));
    BLANK_BIT =  str2double(get(handles.BLANK_BIT,'String'));
    if (get(handles.DEBUG,'Value') == get(handles.DEBUG,'Max'))
        % Checkbox is checked
            DEBUG = 1;
        else
            % Checkbox is not checked
            DEBUG = 0;
    end
        
    ADC_FREQUENCY = str2double(get(handles.ADC_FREQUENCY,'String'));
    SPECTROMETER_FREQUENCY = str2double(get(handles.SPECTROMETER_FREQUENCY,'String'));
    SPECTRAL_WIDTH = str2double(get(handles.SPECTRAL_WIDTH,'String'));
    AMPLITUDE = str2double(get(handles.AMPLITUDE,'String'));
    PULSE90_TIME = str2double(get(handles.PULSE90_TIME,'String'));
    PULSE90_PHASE = str2double(get(handles.PULSE90_PHASE,'String'));
    PULSE180_TIME = str2double(get(handles.PULSE180_TIME,'String'));
    if (get(handles.INCLUDE_90,'Value') == get(handles.INCLUDE_90,'Max'))
        % Checkbox is checked
            INCLUDE_90 = 1;
        else
            % Checkbox is not checked
            INCLUDE_90 = 0;
        end
    
    if (get(handles.BYPASS_FIR,'Value') == get(handles.BYPASS_FIR,'Max'))
        % Checkbox is checked
            BYPASS_FIR = 1;
        else
            % Checkbox is not checked
            BYPASS_FIR = 0;
    end
        
     NUMBER_OF_SCANS = str2double(get(handles.NUMBER_OF_SCANS,'String'));
     TAU = str2double(get(handles.TAU,'String'));
     BLANKING_DELAY = str2double(get(handles.BLANKING_DELAY,'String'));
     TRANS_DELAY = str2double(get(handles.TRANS_DELAY,'String'));
     REPETITION_DELAY = str2double(get(handles.REPETITION_DELAY,'String'));
     
     
     
     
     
function plotRealData(timeValues,realData)

plot(timeValues,realData);
xlabel('Time (milliseconds)');
ylabel('Amplitude');
title('Time Domain - Real Data');
axis tight;
drawnow;

function plotImagData(timeValues,imagData)

plot(timeValues,imagData);
xlabel('Time (milliseconds)');
ylabel('Amplitude');
title('Time Domain - Imaginary Data');
axis tight;
drawnow;

function plotMagData(timeValues,magData)

plot(timeValues,magData);
xlabel('Time (milliseconds)');
ylabel('Amplitude');
title('Time Domain - Magnitude Data');
axis tight;
drawnow;
    


% --- Executes on button press in DEBUG.
function DEBUG_Callback(hObject, eventdata, handles)
% hObject    handle to DEBUG (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of DEBUG



function NUM_POINTS_Callback(hObject, eventdata, handles)
% hObject    handle to NUM_POINTS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NUM_POINTS as text
%        str2double(get(hObject,'String')) returns contents of NUM_POINTS as a double


% --- Executes during object creation, after setting all properties.
function NUM_POINTS_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NUM_POINTS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in ASCII.
function ASCII_Callback(hObject, eventdata, handles)
% hObject    handle to ASCII (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[FILE_NAME, BOARD_NUMBER, BLANK_BIT, DEBUG, ADC_FREQUENCY, SPECTROMETER_FREQUENCY,...
    SPECTRAL_WIDTH, AMPLITUDE, PULSE90_TIME, PULSE90_PHASE, PULSE180_TIME, INCLUDE_90,...
    BYPASS_FIR, NUMBER_OF_SCANS, TAU, BLANKING_DELAY, TRANS_DELAY, REPETITION_DELAY]...
    =pollInputParameters(handles);

if exist('.\LogFiles') == 7
        cd('.\LogFiles');
        
        if exist(FILE_NAME) ~= 7
            error('File does not exist');
        end
        
        cd(FILE_NAME);
        
        s=uiimport(strcat(FILE_NAME, '.txt'));
        assignin('base','s',s);
        cd('..\..\');

end
com=s.data;
assignin('base','com',com);
real=com(1:2:end);
imag=com(2:2:end);
assignin('base','real',real);
assignin('base','imag',imag);

realData=double(real);
imagData=double(imag);
NUM_POINTS = double(length(real));

%pts = NUM_POINTS;
%assignin('base','pts', pts);


timeValues = (1:NUM_POINTS)*(1/SPECTRAL_WIDTH);
assignin('base','timeValues',timeValues);
magData = zeros(1,(length(real)));
n = 1:NUM_POINTS;
magData(n) = sqrt(realData(n).^2+imagData(n).^2);
switch get(handles.timePanel,'SelectedObject')
                case handles.radioReal
                    axes(handles.axes1);
                    plotRealData(timeValues,realData);
                case handles.radioImag
                    axes(handles.axes1);
                    plotImagData(timeValues,imagData);
                case handles.radioMag
                    axes(handles.axes1);
                    plotMagData(timeValues,magData);
end

hHahnecho = getappdata(0, 'hHahnecho');
setappdata(hHahnecho,       'timeValues', timeValues);
setappdata(hHahnecho,         'realData', realData);
setappdata(hHahnecho,         'imagData', imagData);
setappdata(hHahnecho,          'magData', magData);
setappdata(hHahnecho,         'NUM_POINTS', NUM_POINTS);

set(handles.status,'String','ASCII data processed');
drawnow;



function errorChecking(FILE_NAME, BOARD_NUMBER, BLANK_BIT, DEBUG, ADC_FREQUENCY, SPECTROMETER_FREQUENCY,...
    SPECTRAL_WIDTH, AMPLITUDE, PULSE90_TIME, PULSE90_PHASE, PULSE180_TIME, INCLUDE_90,...
    BYPASS_FIR, NUMBER_OF_SCANS, TAU, BLANKING_DELAY, TRANS_DELAY, REPETITION_DELAY)

if (BOARD_NUMBER < 0)
    error('error in board number');
elseif (BLANK_BIT >3 || BLANK_BIT <0)
    error('error in blanking bit');
elseif (SPECTROMETER_FREQUENCY <0.0 || SPECTROMETER_FREQUENCY > 100.0)
    error('error in spectrometer frequency');
elseif (SPECTRAL_WIDTH <0.0 || SPECTRAL_WIDTH> 10000.0)
    error ('error in spectral width');
elseif (PULSE90_TIME<0.065)
    error('error in P1 time');
elseif (PULSE180_TIME <0.065)
    error('error in P2 time');
elseif (AMPLITUDE<0.0 || AMPLITUDE>1.0)
    error('error in amplitude');
elseif (TRANS_DELAY <0.065)
    error ('error in transient delay');
elseif (TAU<0.065)
    error ('error in tau');
elseif (BLANKING_DELAY<0)
    error ('error in blanking delay');
end 

    
