%Created by Ryan J. Smith for SpinCore Technologies 2007
%Modified by Song Kui For SpinCore Technologies 2017


function varargout = spincore_pulse_width_gui(varargin)
% spincore_pulse_width_gui M-file for spincore_pulse_width_gui.fig
%      spincore_pulse_width_gui, by itself, creates a new
%      spincore_pulse_width_gui or
%      raises the existing
%      singleton*.
%
%      H = spincore_pulse_width_gui returns the handle to a new spincore_pulse_width_gui or
%      the handle
%      to
%      the existing singleton*.
%
%      spincore_pulse_width_gui('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in spincore_pulse_width_gui.M with the given input arguments.
%
%      spincore_pulse_width_gui('Property','Value',...) creates a new spincore_pulse_width_gui or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before spincore_pulse_width_gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to spincore_pulse_width_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help spincore_pulse_width_gui

% Last Modified by GUIDE v2.5 29-Jun-2007 11:51:48

if (exist('.\EssentialGuiFiles', 'dir') == 7)
addpath('.\EssentialGuiFiles\');
end

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @spincore_pulse_width_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @spincore_pulse_width_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before spincore_pulse_width_gui is made visible.
function spincore_pulse_width_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to spincore_pulse_width_gui (see VARARGIN)

% Choose default command line output for spincore_pulse_width_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% Check if the GUI is closing
set(handles.figure1,'CloseRequestFcn','closeGUI');
guidata(hObject, handles);
% UIWAIT makes spincore_pulse_width_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


setappdata(0, 'hPulseWidthGui', gcf);
hPulseWidthGui = getappdata(0, 'hPulseWidthGui');

setappdata(hPulseWidthGui, 'dataFlag', 0);
setappdata(hPulseWidthGui, 'stopScanFlag', 0);
setappdata(hPulseWidthGui, 'scanRunningFlag', 0);

%Set default values for input parameters
set(handles.npBox,'string','16384');
set(handles.sfBox,'string','10.8');
set(handles.swBox,'string','3000');
set(handles.transBox,'string','150');
set(handles.repdelayBox,'string','3');
set(handles.numscansBox,'string','1');
set(handles.txphaseBox,'string','0');
set(handles.adcBox,'string','75');
set(handles.ampBox,'string','1');
set(handles.pulsetimeBox,'string','10');
set(handles.blankingBitBox,'string','2');
set(handles.blankingDelayBox,'string','3000.0');
set(handles.firCheck,'value',1);

set(handles.initPulseBox,'string','1');
set(handles.finalPulseBox,'string','45');
set(handles.stepSizeBox,'string','1');

set(handles.buttonNewPlot1,'enable','off');
set(handles.stopButton,'enable','off');

axes(handles.axes1);
xlabel('Pulse Width (microseconds)');
ylabel('Amplitude');
title('Stem Plot');

axes(handles.axes2);
xlabel('Time (milliseconds)');
ylabel('Amplitdue');
title('Current Scan');

set(handles.statusBox,'String','Ready');
drawnow;



% --- Outputs from this function are returned to the command line.
function varargout = spincore_pulse_width_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in scanButton.
function scanButton_Callback(hObject, eventdata, handles)
% hObject    handle to scanButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

error = 0;

set(handles.pulsePanel,'visible','off');
set(handles.resButton,'enable','off');
set(handles.scanButton,'enable','off');
set(handles.stopButton,'enable','on');
drawnow;

hPulseWidthGui = getappdata(0, 'hPulseWidthGui');

if getappdata(hPulseWidthGui, 'scanRunningFlag') == 1
    return;
end

set(handles.buttonNewPlot1,'enable','off');

setappdata(hPulseWidthGui, 'stopScanFlag', 0);
setappdata(hPulseWidthGui, 'scanRunningFlag', 1);

num_points = str2double(get(handles.npBox,'String'));
SF = str2double(get(handles.sfBox,'String'));
SW = str2double(get(handles.swBox,'String'));
trans_time = str2double(get(handles.transBox,'String'));
repetition_delay = str2double(get(handles.repdelayBox,'String'));
num_scans = str2double(get(handles.numscansBox,'String'));
tx_phase = str2double(get(handles.txphaseBox,'String'));
adc_freq = str2double(get(handles.adcBox,'String'));
amp_val = str2double(get(handles.ampBox,'String'));
blanking_bit = str2double(get(handles.blankingBitBox,'String'));
blanking_delay = str2double(get(handles.blankingDelayBox,'String'));

origRepDelay = repetition_delay;

initPulseWidth = str2double(get(handles.initPulseBox,'String'));
finalPulseWidth = str2double(get(handles.finalPulseBox,'String'));
pulseStepSize = str2double(get(handles.stepSizeBox,'String'));
pulse_time = initPulseWidth;

totalScans = floor(((finalPulseWidth - initPulseWidth)/pulseStepSize))+1;

realDataAvg = zeros(totalScans, 1);
imagDataAvg = zeros(totalScans, 1);
magDataAvg = zeros(totalScans, 1);

if (get(handles.firCheck,'Value') == get(handles.firCheck,'Max'))
    % Checkbox is checked
    bypass_fir = 1;
else
    % Checkbox is not checked
    bypass_fir = 0;
end

if (get(handles.radioHard,'Value') == 1)
    shape = 'Hard';
else
    shape = 'Sinc';
end

setappdata(hPulseWidthGui, 'num_points', num_points);
setappdata(hPulseWidthGui, 'SF', SF);
setappdata(hPulseWidthGui, 'SW', SW);
setappdata(hPulseWidthGui, 'pulse_time', pulse_time);
setappdata(hPulseWidthGui, 'blanking_bit', blanking_bit);
setappdata(hPulseWidthGui, 'blanking_delay', blanking_delay);
setappdata(hPulseWidthGui, 'trans_time', trans_time);
setappdata(hPulseWidthGui, 'repetition_delay', repetition_delay);
setappdata(hPulseWidthGui, 'num_scans', num_scans);
setappdata(hPulseWidthGui, 'tx_phase', tx_phase);
setappdata(hPulseWidthGui, 'adc_freq', adc_freq);
setappdata(hPulseWidthGui, 'amp_val', amp_val);
setappdata(hPulseWidthGui, 'bypass_fir', bypass_fir);
setappdata(hPulseWidthGui, 'shape', shape);

setappdata(hPulseWidthGui, 'initPulseWidth', initPulseWidth);
setappdata(hPulseWidthGui, 'finalPulseWidth', finalPulseWidth);
setappdata(hPulseWidthGui, 'pulseStepSize', pulseStepSize);


timeData = zeros(1,totalScans);
for i = 1:totalScans
    timeData(i) = initPulseWidth + (i-1)*pulseStepSize;
end

setappdata(hPulseWidthGui, 'timeData', timeData);


%Check to ensure that all input parameters have been assigned valid values
if (num_points < 1 || num_points > 16384 || isnan(num_points) || mod(num_points,2) == 1)
    errordlg('Number of points must be an even integer between 2 and 16384.');
    error = 1;
elseif (SF < 0 || isnan(SF))
    errordlg('Spectrometer frequency must be a number greater than or equal to 0');
    error = 1;
elseif (SW < 0 || isnan(SW))
    errordlg('Spectral width must be a number greater than or equal to 0');
    error = 1;
elseif (pulse_time < 0.065 || isnan(pulse_time))
    errordlg('Pulse time must be a number greater than or equal to 0.065');
    error = 1;
elseif (trans_time < 0.065 || isnan(trans_time))
    errordlg('Ringdown time must be a number greater than or equal to 0.065');
    error = 1;
elseif (repetition_delay < 0 || isnan(repetition_delay))
    errordlg('Repetition delay must be a number greater than or equal to 0');
    error = 1;
elseif (num_scans < 1 || isnan(num_scans))
    errordlg('At least one scan must be performed.');
    error = 1;
elseif (tx_phase < 0 || tx_phase > 360 || isnan(tx_phase))
    errordlg('Output phase must be between 0 and 360 degrees');
    error = 1;
elseif (adc_freq < 0 || isnan(adc_freq))
    errordlg('Please enter correct clock time for your board');
    error = 1;
elseif (amp_val < 0 || amp_val > 1 || isnan(amp_val))
    errordlg('Amplitude must be a value between 0 and 1.');
    error = 1;
elseif (blanking_bit < 0 || blanking_bit > 8 || isnan(blanking_bit))
    errordlg('Blanking Bit must be between 0 and 7.');
    error = 1;
elseif (blanking_delay < 0.065 || isnan(blanking_delay))
    errordlg('Blanking Delay must be greater than 0.065 (65 ns).');
    error = 1;
end

%If input parameters are valid, begin series of scans
if error == 0
           
    set(handles.statusBox,'String','Scan in Progress');

%Set pulse_time so it works appropriately with code below.
            
%Begin loop of scans
    for currentScan = 1:(totalScans)
        drawnow;

%If user has issued Stop Scan command, break from loop, end scans.
        if getappdata(hPulseWidthGui, 'stopScanFlag') == 1
            break
        end         

%Set the appropriate pulse_time
        pulse_time = timeData(currentScan);
        
        setappdata(hPulseWidthGui, 'pulse_time', pulse_time);
        
%Perform Single Pulse Scan and proceed once scan has run in entirety
        SpnmrWithDelay(num_points, SF, SW, pulse_time, trans_time,... 
        repetition_delay, num_scans, tx_phase, bypass_fir,... 
        adc_freq, amp_val, blanking_bit, blanking_delay, shape);     

%Download data from RadioProcessor, convert to double, calculate magnitude
        tic;
        [realData,imagData]=pbGetData();
        
        realData = double(realData(1:num_points));
        imagData = double(imagData(1:num_points));
        
        for n = 1:num_points
            magData(n) = sqrt(realData(n)^2+imagData(n)^2);
        end

%Calculate amplitude values of FID using avgFactor number of values
%following the specified offset
        
        avgFactor = 10;
        offset = 5;
        
        realDataAvg(currentScan) = sum(realData(offset:(offset+avgFactor-1)))/avgFactor;
        imagDataAvg(currentScan) = sum(imagData(offset:(offset+avgFactor-1)))/avgFactor;
        magDataAvg(currentScan) = sum(magData(offset:(offset+avgFactor-1)))/avgFactor;
        
%Store this calculated amplitude to application memory
        setappdata(hPulseWidthGui, 'realDataAvg', realDataAvg);
        setappdata(hPulseWidthGui, 'imagDataAvg', imagDataAvg);
        setappdata(hPulseWidthGui, 'magDataAvg', magDataAvg)
        setappdata(hPulseWidthGui, 'currentScan', currentScan);

%Depending on which plot has been selected, select the appropriate values
        if get(handles.radioReal,'Value')==1
            ampData = realDataAvg;
            rawData = realData;
        elseif get(handles.radioImag,'Value')==1
            ampData = imagDataAvg;
            rawData = imagData;
        elseif get(handles.radioMag,'Value')==1
            ampData = magDataAvg;
            rawData = magData;
        end

%Whichever plot has been selected, store that value as the current
%amplitude data in application memory
        setappdata(hPulseWidthGui, 'ampData', ampData);
        
%Plot the FID and Amplitude information that has been indicated above
        if get(handles.radioStem,'Value')==1
            axes(handles.axes1);
            pulseStepSize = pulseStepSize;
            stem(timeData(1:currentScan),ampData(1:currentScan));
            xlabel('Pulse Width (microseconds)');
            ylabel('Amplitude');
            title('Stem Plot');
            axis([initPulseWidth finalPulseWidth -max(abs(ampData)) max(abs(ampData))]);         
            
        elseif get(handles.radioConnect,'Value')==1
            axes(handles.axes1);
            pulseStepSize = pulseStepSize;
            plot(timeData(1:currentScan),ampData(1:currentScan));
            xlabel('PulseWidth (microseconds)');
            ylabel('Amplitude');
            title('Connected Plot');
            axis([initPulseWidth finalPulseWidth -max(abs(ampData)) max(abs(ampData))]);
        end
 
        timeValues = (1:num_points)*(1/SW);
        axes(handles.axes2);
        plot(timeValues,rawData);
        title('Current Scan Data');
        ylabel('Amplitude');
        xlabel('Time (milliseconds)');
        
        drawnow;
                      
        t = toc;
        
        if origRepDelay - t > 0;
        repetition_delay = origRepDelay - t;
        end
        
        if t > origRepDelay
            repetition_delay = 0.001;
        end
       
    end

    if getappdata(hPulseWidthGui, 'stopScanFlag') == 1
        set(handles.statusBox,'String','Scan Stopped');
    else
        [pw90,pw90Index] = max(magDataAvg);
        set(handles.pw90Box,'string',(pw90Index-1)*pulseStepSize+initPulseWidth);
        
        filteredData = zeros(totalScans,1);
        
        filteredData = filter([1/4,1/4,1/4,1/4],1,magDataAvg);
        
        filteredData = filteredData(2:length(filteredData));
                      
         for n = pw90Index:(length(filteredData)-1)
           if filteredData(n) < filteredData(n-1)
               if filteredData(n) < filteredData(n+1)
               pw180Index = n;
               set(handles.pw180Box,'string',(pw180Index-1)*pulseStepSize+initPulseWidth);
               drawnow;
               break;
               end
           end
         end
        
               
        set(handles.pulsePanel,'visible','on');
        set(handles.statusBox,'String','Ready');
    end
    
    set(handles.stopButton,'enable','off');
    set(handles.scanButton,'enable','on');
    set(handles.resButton,'enable','on');
    set(handles.buttonNewPlot1,'enable','on');
    drawnow;
    
end

    setappdata(hPulseWidthGui, 'scanRunningFlag', '0');
        

% --- Executes on button press in buttonNewPlot1.
function buttonNewPlot1_Callback(hObject, eventdata, handles)
% hObject    handle to buttonNewPlot1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hPulseWidthGui = getappdata(0, 'hPulseWidthGui');

initPulseWidth = getappdata(hPulseWidthGui, 'initPulseWidth');
finalPulseWidth = getappdata(hPulseWidthGui, 'finalPulseWidth');
pulseStepSize = getappdata(hPulseWidthGui, 'pulseStepSize');
ampData = getappdata(hPulseWidthGui, 'ampData');
currentScan = getappdata(hPulseWidthGui, 'currentScan');
timeData = getappdata(hPulseWidthGui, 'timeData');

if get(handles.radioStem,'Value')==1
    figure;
    stem(timeData(1:currentScan),ampData(1:currentScan));
    xlabel('Pulse Width (microseconds)');
    ylabel('Amplitude');
    title('Stem Plot');
    axis([initPulseWidth finalPulseWidth -max(abs(ampData)) max(abs(ampData))]);
elseif get(handles.radioConnect,'Value')==1
    figure;
    plot(timeData(1:currentScan),ampData(1:currentScan));
    xlabel('Pulse Width (microseconds)');
    ylabel('Amplitude');
    title('Connected Plot');
    axis([initPulseWidth finalPulseWidth -max(abs(ampData)) max(abs(ampData))]);
end

% --------------------------------------------------------------------
function stylePanel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to stylePanel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hPulseWidthGui = getappdata(0, 'hPulseWidthGui');

scanFlag = getappdata(hPulseWidthGui,'scanFlag');

initPulseWidth = getappdata(hPulseWidthGui, 'initPulseWidth');
finalPulseWidth = getappdata(hPulseWidthGui, 'finalPulseWidth');
pulseStepSize = getappdata(hPulseWidthGui, 'pulseStepSize');
ampData = getappdata(hPulseWidthGui, 'ampData');
currentScan = getappdata(hPulseWidthGui, 'currentScan');
timeData = getappdata(hPulseWidthGui, 'timeData');

if scanFlag == 0
    return;
end

switch get(hObject,'Tag')   % Get Tag of selected object

    case 'radioStem'
        axes(handles.axes1);
        stem(timeData(1:currentScan),ampData(1:currentScan));
        xlabel('Pulse Width (microseconds)');
        ylabel('Amplitude');
        title('Stem Plot');
        axis([initPulseWidth finalPulseWidth -max(abs(ampData)) max(abs(ampData))]);

    case 'radioConnect'
        axes(handles.axes1);
        plot(timeData(1:currentScan),ampData(1:currentScan));
        xlabel('Pulse Width (microseconds)');
        ylabel('Amplitude');
        title('Connected Plot');
        axis([initPulseWidth finalPulseWidth -max(abs(ampData)) max(abs(ampData))]);

end

% --------------------------------------------------------------------
function dataPanel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to dataPanel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hPulseWidthGui = getappdata(0, 'hPulseWidthGui');

realDataAvg = getappdata(hPulseWidthGui, 'realDataAvg');
imagDataAvg = getappdata(hPulseWidthGui, 'imagDataAvg');
magDataAvg = getappdata(hPulseWidthGui, 'magDataAvg');
initPulseWidth = getappdata(hPulseWidthGui, 'initPulseWidth');
finalPulseWidth = getappdata(hPulseWidthGui, 'finalPulseWidth');
pulseStepSize = getappdata(hPulseWidthGui, 'pulseStepSize');
currentScan = getappdata(hPulseWidthGui, 'currentScan');
timeData = getappdata(hPulseWidthGui, 'timeData');
ampData = getappdata(hPulseWidthGui, 'ampData');

switch get(hObject,'Tag')   % Get Tag of selected object
    case 'radioReal'
        ampData = realDataAvg;            
    case 'radioImag'
        ampData = imagDataAvg;
    case 'radioMag'
        ampData = magDataAvg;
end

if get(handles.radioStem,'Value')==1
    axes(handles.axes1);
    stem(timeData(1:currentScan),ampData(1:currentScan));
    xlabel('Pulse Width (microseconds)');
    ylabel('Amplitude');
    title('Stem Plot');
    axis([initPulseWidth finalPulseWidth -max(abs(ampData)) max(abs(ampData))]);
elseif get(handles.radioConnect,'Value')==1
    axes(handles.axes1);
    plot(timeData(1:currentScan),ampData(1:currentScan));
    xlabel('Pulse Width (microseconds)');
    ylabel('Amplitude');
    title('Connected Plot');
    axis([initPulseWidth finalPulseWidth -max(abs(ampData)) max(abs(ampData))]);
end

setappdata(hPulseWidthGui, 'ampData', ampData);


% --- Executes on button press in stopButton.
function stopButton_Callback(hObject, eventdata, handles)
% hObject    handle to stopButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hPulseWidthGui = getappdata(0, 'hPulseWidthGui');
setappdata(hPulseWidthGui, 'stopScanFlag', 1);

pbStop();
set(handles.statusBox,'string','Stopping Scan...');
drawnow;


% --- Executes on button press in resButton.
function resButton_Callback(hObject, eventdata, handles)
% hObject    handle to resButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hPulseWidthGui = getappdata(0, 'hPulseWidthGui');
set(handles.scanButton,'enable','off');
set(handles.stopButton,'enable','off');

if getappdata(hPulseWidthGui, 'scanRunningFlag') == 1
    return;
end

error = 0;

num_points = str2double(get(handles.npBox,'String'));
SF = str2double(get(handles.sfBox,'String'));
SW = str2double(get(handles.swBox,'String'));
pulse_time = str2double(get(handles.pulsetimeBox,'String'));
trans_time = str2double(get(handles.transBox,'String'));
repetition_delay = str2double(get(handles.repdelayBox,'String'));
num_scans = str2double(get(handles.numscansBox,'String'));
tx_phase = str2double(get(handles.txphaseBox,'String'));
adc_freq = str2double(get(handles.adcBox,'String'));
amp_val = str2double(get(handles.ampBox,'String'));
blanking_bit = str2double(get(handles.blankingBitBox,'String'));
blanking_delay = str2double(get(handles.blankingDelayBox,'String'));

if (get(handles.firCheck,'Value') == get(handles.firCheck,'Max'))
    % Checkbox is checked
    bypass_fir = 1;
else
    % Checkbox is not checked
    bypass_fir = 0;
end

if (get(handles.radioHard,'Value') == 1)
    shape = 'Hard';
else
    shape = 'Sinc';
end

if (num_points < 1 || num_points > 16384 || isnan(num_points) || mod(num_points,2) == 1)
    errordlg('Number of points must be an even integer between 2 and 16384.');
    error = 1;
elseif (SF < 0 || isnan(SF))
    errordlg('Spectrometer frequency must be a number greater than or equal to 0');
    error = 1;
elseif (SW < 0 || isnan(SW))
    errordlg('Spectral width must be a number greater than or equal to 0');
    error = 1;
elseif (trans_time < 0.065 || isnan(trans_time))
    errordlg('Ringdown time must be a number greater than or equal to 0.065');
    error = 1;
elseif (repetition_delay < 0 || isnan(repetition_delay))
    errordlg('Repetition delay must be a number greater than or equal to 0');
    error = 1;
elseif (num_scans < 1 || isnan(num_scans))
    errordlg('At least one scan must be performed.');
    error = 1;
elseif (tx_phase < 0 || tx_phase > 360 || isnan(tx_phase))
    errordlg('Output phase must be between 0 and 360 degrees');
    error = 1;
elseif (adc_freq < 0 || isnan(adc_freq))
    errordlg('Please enter correct clock time for your board');
    error = 1;
elseif (amp_val < 0 || amp_val > 1 || isnan(amp_val))
    errordlg('Amplitude must be a value between 0 and 1.');
    error = 1;
elseif (blanking_bit < 0 || blanking_bit > 8 || isnan(blanking_bit))
    errordlg('Blanking Bit must be between 0 and 7.');
    error = 1;
elseif (blanking_delay < 0.065 || isnan(blanking_delay))
    errordlg('Blanking Delay must be greater than 0.065 (65 ns).');
    error = 1;
end

if error == 0

    set(handles.statusBox,'String','Detecting Resonance Frequency');
    drawnow;
    
    SpnmrWithDelay(num_points, SF, SW, pulse_time, trans_time, repetition_delay,...
        num_scans, tx_phase, bypass_fir, adc_freq, amp_val, blanking_bit, blanking_delay, shape);  

    [realRes, imagRes] = pbGetData();
    realRes = double(realRes);
    imagRes = double(imagRes);
    
    for n = 1:num_points
        compRes(n) = realRes(n)+i*imagRes(n);
    end
    
    compResFft = fft(compRes);
    [maxVal,index] = max(compResFft);
    if index > num_points/2
        offset = -1*(num_points-index+1)*SW*(1/num_points)*(1/1000);
    else
        offset = SW*(index-1)*(1/num_points)*(1/1000);
    end
    
    if index > num_points/2
        resSF = SF + offset;
    else
        resSF = SF + offset;
    end
        
    set(handles.sfBox,'String',resSF);
    set(handles.scanButton,'enable','on');
    set(handles.stopButton,'enable','on');
    set(handles.statusBox,'String','Ready');
    drawnow;
    
end






function pw90Box_Callback(hObject, eventdata, handles)
% hObject    handle to pw90Box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pw90Box as text
%        str2double(get(hObject,'String')) returns contents of pw90Box as a double


% --- Executes during object creation, after setting all properties.
function pw90Box_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pw90Box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function pw180Box_Callback(hObject, eventdata, handles)
% hObject    handle to pw180Box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pw180Box as text
%        str2double(get(hObject,'String')) returns contents of pw180Box as a double


% --- Executes during object creation, after setting all properties.
function pw180Box_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pw180Box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes during object creation, after setting all properties.
function ampBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ampBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function statusBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to statusBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function npBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to npBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function sfBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sfBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function swBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to swBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function transBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to transBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function repdelayBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to repdelayBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function numscansBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numscansBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function txphaseBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txphaseBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function adcBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to adcBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function initPulseBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to initPulseBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes during object creation, after setting all properties.
function finalPulseBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to finalPulseBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes during object creation, after setting all properties.
function stepSizeBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to stepSizeBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes during object creation, after setting all properties.
function blankingBitBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to blankingBitBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function blankingDelayBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to blankingDelayBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function pulsetimeBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pulsetimeBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%-----------------------------------------------------------
function npBox_Callback(hObject, eventdata, handles)
function sfBox_Callback(hObject, eventdata, handles)
function swBox_Callback(hObject, eventdata, handles)
function transBox_Callback(hObject, eventdata, handles)
function repdelayBox_Callback(hObject, eventdata, handles)
function numscansBox_Callback(hObject, eventdata, handles)
function txphaseBox_Callback(hObject, eventdata, handles)
function adcBox_Callback(hObject, eventdata, handles)
function ampBox_Callback(hObject, eventdata, handles)
function firCheck_Callback(hObject, eventdata, handles)
function initPulseBox_Callback(hObject, eventdata, handles)
function finalPulseBox_Callback(hObject, eventdata, handles)
function stepSizeBox_Callback(hObject, eventdata, handles)
function blankingBitBox_Callback(hObject, eventdata, handles)
function blankingDelayBox_Callback(hObject, eventdata, handles)
function pulsetimeBox_Callback(hObject, eventdata, handles)
%-----------------------------------------------------------
