%Created by Ryan J. Smith for SpinCore Technologies 2007
%Modified by Song Kui For SpinCore Technologies 2017
 

%% SpinCore NMR CYCLOPS GUI
function varargout = spincore_spnmr_gui(varargin)
% SPINCORE_SPNMR_GUI M-file for spincore_spnmr_gui.fig
%      SPINCORE_SPNMR_GUI, by itself, creates a new SPINCORE_SPNMR_GUI or raises the existing
%      singleton*.
%
%      H = SPINCORE_SPNMR_GUI returns the handle to a new SPINCORE_SPNMR_GUI or the handle to
%      the existing singleton*.
%
%      SPINCORE_SPNMR_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SPINCORE_SPNMR_GUI.M with the given input arguments.
%
%      SPINCORE_SPNMR_GUI('Property','Value',...) creates a new SPINCORE_SPNMR_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before spincore_nmr_CYCLOPS_gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to spincore_spnmr_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help spincore_spnmr_gui

% Last Modified by GUIDE v2.5 26-Jul-2017 11:44:08

if (exist('.\EssentialGuiFiles\', 'dir') == 7)
    addpath('.\EssentialGuiFiles\');
end

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @spincore_spnmr_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @spincore_spnmr_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


%% Opening Function

% --- Executes just before spincore_spnmr_gui is made visible.
function spincore_spnmr_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to spincore_spnmr_gui (see VARARGIN)

% Choose default command line output for spincore_spnmr_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);
handles.guifig = gcf;
% Set timer object with 0.2 seconds interval 
handles.timer = timer('TimerFcn',{@timer_function,handles.guifig},'BusyMode','Drop','ExecutionMode','FixedRate','Period',0.2);
    
% Check if the GUI is closing
set(handles.figure1,'CloseRequestFcn',{@checkCloseGUI,handles});
guidata(handles.guifig, handles);

% UIWAIT makes spincore_spnmr_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);

setappdata(0, 'hCyclopsGui', gcf);
hCyclopsGui = getappdata(0, 'hCyclopsGui');

%Initialize dataFlag and continuousFlag to 0
setappdata(hCyclopsGui, 'dataFlag', 0);
setappdata(hCyclopsGui, 'continuousFlag', 0);

%Initialize values for input parameters
set(handles.npBox,'string','16384');
set(handles.sfBox,'string','21.2');
set(handles.swBox,'string','3000');
set(handles.pulseBox,'string','1.5');
set(handles.transBox,'string','120');
set(handles.repdelayBox,'string','0.1');
set(handles.numscansBox,'string','4');
set(handles.txphaseBox,'string','0');
set(handles.adcBox,'string','75');
set(handles.ampBox,'string','1');
set(handles.filenameBox,'string','SPNMR001');
set(handles.firCheck,'value',1);

set(handles.blankbitBox,'string', '2');
set(handles.blankdlyBox,'string', '3000.0');
set(handles.cyclopsCheck,'value',1);
set(handles.boardNum,'string','0');

%Ensure that the user cannot access features that require a scan first
set(handles.snrButton,'enable','off');
set(handles.dataButton,'enable','off');
set(handles.stopButton,'enable','off');
set(handles.buttonNewPlot1,'enable','off');
set(handles.buttonNewPlot2,'enable','off');
%Indicate that the initialization is complete and interface is ready
set(handles.statusBox,'String','Ready');
pos = get(handles.progressBack,'Position');
set(handles.progressBar,'Position',[pos(1)+0.002 pos(2)+0.002 0.001 pos(4)-0.001]);
drawnow;


%% Output Function
% --- Outputs from this function are returned to the command line.
function varargout = spincore_spnmr_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



%% Start Acquisition Button Callback
% --- Executes on button press in scanButton.
function scanButton_Callback(hObject, eventdata, handles)
% hObject    handle to scanButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hCyclopsGui = getappdata(0, 'hCyclopsGui');

%Indicate to user that the scan is underway
%set(handles.statusBox,'String','Scan in Progress');
drawnow;
%Call subfunction that polls that required input parameters
[num_points, SF, SW, pulse_time, trans_time, repetition_delay, num_scans, tx_phase, fname, bypass_fir, adc_freq, amp_val, shape, num_Boards, blanking_bit, blanking_delay, run_Cyclops ]= pollInputParameters(handles);

%Check input parameters to ensure they are all valid
errorFlag = errorCheckParameters(num_points, SF, SW, pulse_time, ...
                trans_time, repetition_delay, num_scans, tx_phase, ...
                adc_freq, amp_val, shape, blanking_bit, blanking_delay, run_Cyclops);
            
%Store input parameters to application memory and scan only if no errors                
if errorFlag == 0
    storeInputParameters(num_points, SF, SW, pulse_time, trans_time, ...
                repetition_delay, num_scans, tx_phase, fname, bypass_fir, adc_freq, ...
                amp_val, shape, blanking_bit, blanking_delay, run_Cyclops);
    
%Function call to mex-function that handles communication with 
%RadioProcessor board
if (get(handles.cyclopsCheck,'Value') == 1)
    [errorCyclops, totalTime] = CyclopsScan(num_points, SF, SW, pulse_time, trans_time, repetition_delay, num_scans, tx_phase, bypass_fir, adc_freq, amp_val, shape, blanking_bit, blanking_delay, num_Boards);
    if errorCyclops == 0
        set([handles.boardNum handles.npBox handles.sfBox handles.swBox handles.pulseBox handles.transBox ...
        handles.repdelayBox handles.numscansBox handles.txphaseBox handles.adcBox handles.ampBox ...
         handles.blankbitBox handles.blankdlyBox handles.firCheck handles.cyclopsCheck],'enable','off');
        set(handles.stopButton,'enable','on');
        set(handles.dataButton,'enable','on');
        if strcmp(get(handles.timer,'Running'),'off')
            start(handles.timer);
            guidata(handles.guifig,handles);
        end
        drawnow;
    elseif errorCyclops == -1       %If the board does not support CYCLOPS feature
        str = sprintf('Your RadioProcessor firmware does not support CYCLOPS. \nPlease uncheck the "CYCLOPS" box to continue');
        msgbox( str ,'Error','warn');   
        set(handles.inputPanel,'enable','on');
    elseif errorCyclops == -2       %If Number of Scan is incorrect to run CYCLOPS
        str = sprintf('Please check the "Number of Scans". \nTo run CYCLOPS, the number of scans must be a multiple of 4');
        msgbox(str,'Error','help');
        set(handles.inputPanel,'enable','on');
    elseif errorCyclops == -3       %If no boards are found in the system
        msgbox('No boards found','Error','error');
        set([handles.boardNum handles.npBox handles.sfBox handles.swBox handles.pulseBox handles.transBox ...
        handles.repdelayBox handles.numscansBox handles.txphaseBox handles.adcBox handles.ampBox ...
         handles.blankbitBox handles.blankdlyBox handles.firCheck handles.cyclopsCheck],'enable','on');
    else
           set([handles.boardNum handles.npBox handles.sfBox handles.swBox handles.pulseBox handles.transBox ...
        handles.repdelayBox handles.numscansBox handles.txphaseBox handles.adcBox handles.ampBox ...
         handles.blankbitBox handles.blankdlyBox handles.firCheck handles.cyclopsCheck],'enable','off');
    end
    
    %Allow user to stop the scan and download data after successfully 
%initiating scan
else
    [error] = SinglepulsenmrScan(num_points, SF, SW, pulse_time, trans_time, ... 
                repetition_delay, num_scans, tx_phase, bypass_fir, adc_freq, ...
                amp_val, shape, blanking_bit, blanking_delay, num_Boards);
    if error == 0
        set(handles.stopButton,'enable','on');
        set(handles.dataButton,'enable','on');
        set([handles.boardNum handles.npBox handles.sfBox handles.swBox handles.pulseBox handles.transBox ...
        handles.repdelayBox handles.numscansBox handles.txphaseBox handles.adcBox handles.ampBox ...
        handles.filenameBox handles.blankbitBox handles.blankdlyBox handles.firCheck handles.cyclopsCheck],'enable','off');
        if strcmp(get(handles.timer,'Running'),'off')
            start(handles.timer);
            guidata(handles.guifig,handles);
        end
        drawnow;
    elseif error == -1
        h=msgbox('No boards found','Error','error');
    elseif error == -2
        h=msgbox('Failed programming the board','Error','error');
    end
end
end

%set(handles.statusBox,'String','Ready');
drawnow;



%% Download Data Button Callback
% --- Executes on button press in dataButton.
function dataButton_Callback(hObject, eventdata, handles)
% hObject    handle to dataButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
hCyclopsGui = getappdata(0, 'hCyclopsGui');
%Get last-used parameters from application memory rather than from the
%input parameter boxes.  This ensures that if the user has changed the
%input values between the time of the scan and the time data is
%downloading, the values will still match appropriately.
timerWasRunning = 0;
     if strcmp(get(handles.timer, 'Running'),'on')
         timerWasRunning = 1;
         stop(handles.timer);
     end 
num_points = getappdata(hCyclopsGui, 'num_points');
SF = getappdata(hCyclopsGui, 'SF');
SW = getappdata(hCyclopsGui, 'SW');
pulse_time = getappdata(hCyclopsGui, 'pulse_time');
trans_time = getappdata(hCyclopsGui, 'trans_time');
repetition_delay = getappdata(hCyclopsGui, 'repetition_delay');
num_scans = getappdata(hCyclopsGui, 'num_scans');
tx_phase = getappdata(hCyclopsGui, 'tx_phase');
%fname = getappdata(hCyclopsGui, 'fname');
fname = get(handles.filenameBox,'String');
if isempty(fname)||~ischar(fname)
    msgbox('Please check File Name.','Error','warn');
    return;
end
adc_freq = getappdata(hCyclopsGui, 'adc_freq');
amp_val = getappdata(hCyclopsGui, 'amp_val');
blanking_bit = getappdata(hCyclopsGui, 'blanking_bit');
blanking_delay = getappdata(hCyclopsGui, 'blanking_delay');
bypass_fir = getappdata(hCyclopsGui, 'bypass_fir');
shape = getappdata(hCyclopsGui, 'shape');
clocktime = clock;

%Initialize the data matrices to contain all zeros
magData=zeros(1,num_points);
realData=zeros(1,num_points);
imagData=zeros(1,num_points);


set(handles.progressBar,'String','Retrieving data.');
drawnow;

%Poll the RadioProcessor to get information pertaining to the current scan
[pbstatus, pbscans] = pbReadStatus();
pbstatus=double(pbstatus);
pbscans=double(pbscans);

if (pbstatus < 0 || isnan(pbstatus))
    pbstatus = 0;
end

if (pbscans < 0 || isnan(pbscans))
    pbscans = 0;
end

% Here a subdirectory is either created or overwritten, depending on
% whether or not it already exists.  The data is then downloaded and stored
% to this directory.

if (exist('.\LogFiles', 'dir') == 7)
    cd('.\LogFiles');
    %Check if the file already exists in the folder
    if (exist(fname, 'dir') == 7)
        str = sprintf('The filname %s already exists.\nDo you want to overwrite it?',fname);
        selection = questdlg(str,...
                     'Writing Data',...
                     'Yes','No','Yes');
        switch selection
            case 'Yes'
                %Continue
            case 'No'
                set(handles.progressBar,'String','Canceled');
                cd('..\');
                return;
        end       
    else 
        mkdir(cd,fname);
    end
    cd(fname);
    addpath('..\..\EssentialGuiFiles');

    %pbGetDataPlus creates ASCII, JCAMP and FELIX files containing pertinent
    %scan information while also storing the real and imaginary data values to 
    %vectors within MATLAB
    [realData,imagData,status]=pbGetDataPlus(num_points, SF, SW, fname, num_scans, adc_freq, pulse_time, trans_time, repetition_delay, tx_phase, bypass_fir, amp_val, shape);
    cd('..\..\');

else
    cd('..\LogFiles');
  
    if (exist(fname, 'dir') ~= 7)
        mkdir(cd,fname);
    end
    
    cd(fname);
    addpath('..\..\EssentialGuiFiles');

%pbGetDataPlus creates ASCII, JCAMP and FELIX files containing pertinent
%scan information while also storing the real and imaginary data values to 
%vectors within MATLAB
  
    [realData,imagData, status]=pbGetDataPlus(num_points, SF, SW, fname, num_scans, adc_freq, pulse_time, trans_time, repetition_delay, tx_phase, bypass_fir, amp_val, shape);
    cd('..\..\EssentialGuiFiles');
    
end
%If the data downloaded properly, proceed with analysis and creation of log
%files



if status == 0

    %set(handles.statusBox,'String','Retrieval complete! Plotting data.');
    %drawnow;

%Set the dataFlag to 1.  This indicates that data has been downloaded
    dataFlag = 1;
    
%Convert values in data matrices from INT32 to double since MATLAB will not
%perform many necessary operations on INT32

    realData=double(realData(1:num_points));
    imagData=double(imagData(1:num_points));

%Initialize a vector containing the proper time values needed to correctly
%plot the data
    timeValues = (1:num_points)*(1/SW);

%Store the data magnitude values in the magData vector
    n = 1:num_points;
    magData(n) = sqrt(realData(n).^2+imagData(n).^2);

%Call the subfunction which generates the Complex Power Spectral Density
%as well as the proper frequency values needed for plotting.
    [compPsd,freqValues] = generatePsd(num_points, SW, realData, imagData);
    %{
    assignin('base','freqValues',freqValues);
    assignin('base','compPsd',compPsd);
    
    
    interpolation = 
    
    [peak, indexPeak]= max(compPsd);
    peakFreq=freqValues(indexPeak);
    
    
    
    
    half=(1/2)*peak;
    for n=1:indexPeak
        difference(n)=abs(compPsd(n)-half);
    end
    
    [~, I] = min(difference);
    left=compPsd(I);
    freqLeft = freqValues(I);
    m=(peak-left)/(indexPeak-freqLeft);
    frq=(half-left)/m;
    assignin('base','m',m);
    assignin('base','frq',frq);
    
    
    
    
    
    
    
    k=1;
    for n=(I+1):length(compPsd)
        differ(k)=abs(compPsd(n)-half);
        k=k+1;
    end
    
    [rightHalf, I] = min(differ);
    right=compPsd(I);
    assignin('base','compPsd',compPsd);
    assignin('base','difference',difference);
    assignin('base','differ',differ);
    assignin('base','left',left);
    assignin('base','right',right);
    %}
    
    
    
    
    
   
%Save all pertinent data in a MAT-file and place it along with the other
%log files generated by pbGetDataPlus
    title = 'Spincore CYCLOPS NMR Datafile';
    
    if (exist('.\LogFiles', 'dir') == 7)
        cd('.\LogFiles');
        cd(fname);
        save(fname,'title','clocktime','num_points','SF','SW','pulse_time', ...
        'trans_time', 'repetition_delay','num_scans','tx_phase', ...
        'adc_freq', 'amp_val', 'bypass_fir', 'shape', 'realData', ...
        'imagData', 'magData','timeValues','compPsd','freqValues', ...
        'blanking_bit', 'blanking_delay');

        cd('..\..\');
    else
        cd('..\LogFiles');
        cd(fname);
        save(fname,'clocktime','title','num_points','SF','SW','pulse_time', ...
        'trans_time', 'repetition_delay','num_scans','tx_phase', ...
        'adc_freq', 'amp_val', 'bypass_fir', 'shape', 'realData', ...
        'imagData', 'magData','timeValues','compPsd','freqValues', ...
        'blanking_bit', 'blanking_delay');
         cd('..\..\EssentialGuiFiles');
    end

%Detect which timeseries plot the user has requested and plot it
    switch get(handles.timePanel,'SelectedObject')
        case handles.radioReal
            axes(handles.axes1);
            plotRealData(timeValues,realData);
        case handles.radioImag
            axes(handles.axes1);
            plotImagData(timeValues,imagData);    
        case handles.radioMag
            axes(handles.axes1);
            plotMagData(timeValues,magData);
    end

%Detect which frequency domain plot the user has requested and plot it
    switch get(handles.freqPanel,'SelectedObject')
        case handles.radioSemi
            axes(handles.axes2);
            semilogCompPsd(freqValues,compPsd);
        case handles.radioLinear
            axes(handles.axes2);
            plotCompPsd(freqValues,compPsd);            
    end

%Store generated data to the appropriate locations in application memory    
    setappdata(hCyclopsGui,       'freqValues', freqValues);
    setappdata(hCyclopsGui,          'compPsd', compPsd);
    setappdata(hCyclopsGui,         'realData', realData);
    setappdata(hCyclopsGui,         'imagData', imagData);
    setappdata(hCyclopsGui,          'magData', magData);
    setappdata(hCyclopsGui,       'timeValues', timeValues);
    setappdata(hCyclopsGui,         'dataFlag', dataFlag);
    
%Allow performing SNR calculations or generation of plots in new figures
    set(handles.snrButton,'enable','on');
    set(handles.buttonNewPlot1,'enable','on');
    set(handles.buttonNewPlot2,'enable','on');
    
%Indicate that the interface is ready to receive another command
    set(handles.progressBar,'String','Ready');
    drawnow;
        
elseif status ~= 0
    set(handles.progressBar,'String','Error Retrieving Data');
    drawnow;
end
if timerWasRunning == 1;
    start(handles.timer);
end


%% Time Domain - Plot in New Window Callback
% --- Executes on button press in buttonNewPlot1.
function buttonNewPlot1_Callback(hObject, eventdata, handles)
% hObject    handle to buttonNewPlot1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hCyclopsGui = getappdata(0, 'hCyclopsGui');

realData = getappdata(hCyclopsGui, 'realData');
imagData = getappdata(hCyclopsGui, 'imagData');
magData = getappdata(hCyclopsGui, 'magData');
dataFlag = getappdata(hCyclopsGui, 'dataFlag');
timeValues = getappdata(hCyclopsGui, 'timeValues');

if dataFlag == 0
    %set(handles.statusBox,'String','Error: No data acquired');
    drawnow;
    
elseif dataFlag == 1
    
    switch get(handles.timePanel,'SelectedObject')
        case handles.radioReal
            figure;
            plotRealData(timeValues,realData);
        case handles.radioImag
            figure;
            plotImagData(timeValues,imagData);
        case handles.radioMag
            figure
            plotMagData(timeValues,magData);  
    end

end


%% Time Domain Panel - Selection Change Function
%------------------------------------------------------------
% --- Executes when selected object is changed in timePanel.
function timePanel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in timePanel 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


hCyclopsGui = getappdata(0, 'hCyclopsGui');
realData = getappdata(hCyclopsGui, 'realData');
imagData = getappdata(hCyclopsGui, 'imagData');
magData = getappdata(hCyclopsGui, 'magData');
dataFlag = getappdata(hCyclopsGui, 'dataFlag');
timeValues = getappdata(hCyclopsGui, 'timeValues');

if dataFlag == 0
    set(handles.statusBox,'String','Error: No data acquired yet.');
    drawnow;    

elseif dataFlag == 1

    switch get(hObject,'Tag')   % Get Tag of selected objec
        case 'radioReal'
            axes(handles.axes1);
            plotRealData(timeValues,realData);
            
        case 'radioImag'
            axes(handles.axes1);
            plotImagData(timeValues,imagData);
            
        case 'radioMag'
            axes(handles.axes1);
            plotMagData(timeValues,magData);
            
    end

end




%% Frequency Domain - Plot in New Window Callback
% --- Executes on button press in buttonNewPlot2.
function buttonNewPlot2_Callback(hObject, eventdata, handles)
% hObject    handle to buttonNewPlot2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hCyclopsGui = getappdata(0, 'hCyclopsGui');
freqValues = getappdata(hCyclopsGui, 'freqValues');
compPsd = getappdata(hCyclopsGui, 'compPsd');
dataFlag = getappdata(hCyclopsGui, 'dataFlag');

if dataFlag == 0
    %set(handles.statusBox,'String','Error: No data acquired');
    drawnow;

elseif dataFlag == 1
    
    switch get(handles.freqPanel,'SelectedObject')
        case handles.radioSemi
            figure;
            semilogCompPsd(freqValues,compPsd);
        case handles.radioLinear
            figure;
            plotCompPsd(freqValues,compPsd);
    end

end



%% Menu - File
% --------------------------------------------------------------------
function menuFile_Callback(hObject, eventdata, handles)
% hObject    handle to menuFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



%% Menu - File - Save Settings
% --------------------------------------------------------------------
function menuSaveSettings_Callback(hObject, eventdata, handles)
% hObject    handle to menuSaveSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


title = 'SpinCore CYCLOPS NMR Settings Log';
fname = get(handles.filenameBox,'String');

logname=strcat(fname,'_Log.mat');

[filename, pathname] = uiputfile( ...
{ '*.mat','MAT-files (*.mat)'}, ...
  'Save as',logname);

% If 'Cancel' was selected then return
if isequal([filename,pathname],[0,0])
   return;

else
    
% If filename specified, store variables.
    [num_points, SF, SW, pulse_time, trans_time, repetition_delay, num_scans, ...
        tx_phase, fname, bypass_fir, adc_freq, amp_val, shape,num_Boards, ...
        blanking_bit, blanking_delay, run_Cyclops]= pollInputParameters(handles);

    clocktime = clock;
    
    errorFlag = errorCheckParameters(num_points, SF, SW, pulse_time, ...
                    trans_time, repetition_delay, num_scans, tx_phase, ...
                    adc_freq, amp_val, shape, blanking_bit, blanking_delay,...
                    run_Cyclops);
                
    % Construct the full path and save
    File = fullfile(pathname,filename);
    save(File,'blanking_delay', 'title','clocktime','num_points','SF','SW','pulse_time','trans_time',...
        'blanking_bit','repetition_delay','num_scans','tx_phase','adc_freq',...
        'amp_val','shape','bypass_fir','fname');
    
    % Update the status bar
    set(handles.statusBox,'string','Settings logged.');
    drawnow;
end



%% Menu - File - Load Settings
% --------------------------------------------------------------------
function menuLoadSettings_Callback(hObject, eventdata, handles)
% hObject    handle to menuLoadSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


[filename,pathname] = uigetfile('*.mat','Select the MAT-file');

if isequal([filename,pathname],[0,0])
    return
else
    File = fullfile(pathname,filename);
    logFile = load(File);
end

if  logFile.title == 'SpinCore CYCLOPS NMR Settings Log'
    set(handles.npBox,'string',logFile.num_points);
    set(handles.sfBox,'string',logFile.SF);
    set(handles.swBox,'string',logFile.SW);
    set(handles.pulseBox,'string',logFile.pulse_time);
    set(handles.transBox,'string',logFile.trans_time);
    set(handles.repdelayBox,'string',logFile.repetition_delay);
    set(handles.numscansBox,'string',logFile.num_scans);
    set(handles.txphaseBox,'string',logFile.tx_phase);
    set(handles.adcBox,'string',logFile.adc_freq);
    set(handles.ampBox,'string',logFile.amp_val);
    set(handles.filenameBox,'string',logFile.fname);
    set(handles.blankbitBox,'string',logFile.blanking_bit);
    set(handles.blankdlyBox,'string',logFile.blanking_delay);
    set(handles.firCheck,'value',logFile.bypass_fir);
    set(handles.statusBox,'string','Settings Loaded.');
    drawnow;
else
    set(handles.statusBox,'string','Invalid Log File');
    drawnow;
end



%% Menu - File - Load Data File
% --------------------------------------------------------------------
function menuLoadData_Callback(hObject, eventdata, handles)
% hObject    handle to menuLoadData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd('.\LogFiles');

hCyclopsGui = getappdata(0, 'hCyclopsGui');

[filename,pathname] = uigetfile('*.mat','Select the desired CYCLOPS NMR Datafile');

if isequal([filename,pathname],[0,0])
    cd('..');
    return
else
    File = fullfile(pathname,filename);
    dataFile = load(File);
    cd('..');
end

[M,N] = size(filename);
filename2 = filename(1:(N-4));

if dataFile.title == 'Spincore CYCLOPS NMR Datafile'
    set(handles.npBox,'string',dataFile.num_points);
    set(handles.sfBox,'string',dataFile.SF);
    set(handles.swBox,'string',dataFile.SW);
    set(handles.pulseBox,'string',dataFile.pulse_time);
    set(handles.transBox,'string',dataFile.trans_time);
    set(handles.repdelayBox,'string',dataFile.repetition_delay);
    set(handles.numscansBox,'string',dataFile.num_scans);
    set(handles.txphaseBox,'string',dataFile.tx_phase);
    set(handles.adcBox,'string',dataFile.adc_freq);
    set(handles.ampBox,'string',dataFile.amp_val);
    set(handles.filenameBox,'string',filename2);
    set(handles.blankbitBox,'string',dataFile.blanking_bit);
    set(handles.blankdlyBox,'string',dataFile.blanking_delay);
    set(handles.firCheck,'value',dataFile.bypass_fir);

    set(handles.buttonNewPlot1,'enable','on');
    set(handles.buttonNewPlot2,'enable','on');
    set(handles.snrButton,'enable','on');
    
    setappdata(hCyclopsGui, 'realData', dataFile.realData);
    setappdata(hCyclopsGui, 'imagData', dataFile.imagData);
    setappdata(hCyclopsGui, 'magData', dataFile.magData);
    setappdata(hCyclopsGui, 'timeValues', dataFile.timeValues);
    setappdata(hCyclopsGui, 'compPsd', dataFile.compPsd);
    setappdata(hCyclopsGui, 'freqValues', dataFile.freqValues)

    setappdata(hCyclopsGui, 'dataFlag', 1);

    switch get(handles.timePanel,'SelectedObject')
        case handles.radioReal
            axes(handles.axes1);
            plotRealData(dataFile.timeValues,dataFile.realData);
        case handles.radioImag
            axes(handles.axes1);
            plotImagData(dataFile.timeValues,dataFile.imagData);
        case handles.radioMag
            axes(handles.axes1);
            plotMagData(dataFile.timeValues,dataFile.magData);
    end

    switch get(handles.freqPanel,'SelectedObject')
        case handles.radioSemi
            axes(handles.axes2);
            semilogCompPsd(dataFile.freqValues,dataFile.compPsd);
        case handles.radioLinear
            axes(handles.axes2);
            plotCompPsd(dataFile.freqValues,dataFile.compPsd);
    end
    
end



%% Unused Callback Functions
%-----------------------------------------------------------
%---- Unused Callback Functions ----------------------------
function boardNum_Callback(hObject, eventdata, handles)
function npBox_Callback(hObject, eventdata, handles)
function sfBox_Callback(hObject, eventdata, handles)
function swBox_Callback(hObject, eventdata, handles)
function pulseBox_Callback(hObject, eventdata, handles)
function transBox_Callback(hObject, eventdata, handles)
function repdelayBox_Callback(hObject, eventdata, handles)
function numscansBox_Callback(hObject, eventdata, handles)
function txphaseBox_Callback(hObject, eventdata, handles)
function adcBox_Callback(hObject, eventdata, handles)
function ampBox_Callback(hObject, eventdata, handles)
function filenameBox_Callback(hObject, eventdata, handles)
function blankbitBox_Callback(hObject, eventdata, handles)
function blankdlyBox_Callback(hObject, eventdata, handles)
function firCheck_Callback(hObject, eventdata, handles)
function cyclopsCheck_Callback(hObject, eventdata, handles)
%-----------------------------------------------------------



%% Frequency Domain - Selection Change Function
% --- Executes when selected object is changed in freqPanel.
function freqPanel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in freqPanel 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


hCyclopsGui = getappdata(0, 'hCyclopsGui');
freqValues = getappdata(hCyclopsGui, 'freqValues');
compPsd = getappdata(hCyclopsGui, 'compPsd');
dataFlag = getappdata(hCyclopsGui, 'dataFlag');

if dataFlag == 0
    set(handles.statusBox,'String','Error: No data acquired');
    drawnow;

elseif dataFlag == 1

    switch get(hObject,'Tag')   % Get Tag of selected object
    
        case 'radioSemi'
            axes(handles.axes2);
            semilogCompPsd(freqValues,compPsd);
        
        case 'radioLinear'
            axes(handles.axes2);
            plotCompPsd(freqValues,compPsd);
  
    end

end



%% Scan Continuously Button Callback
% --- Executes on button press in contButton.
function contButton_Callback(hObject, eventdata, handles)
% hObject    handle to contButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hCyclopsGui = getappdata(0, 'hCyclopsGui');

continuousFlag = getappdata(hCyclopsGui, 'continuousFlag');

set(handles.stopButton, 'enable', 'on');

set(handles.scanButton, 'enable', 'off');
set(handles.dataButton, 'enable', 'off');
set(handles.resButton, 'enable', 'off');
set(handles.snrButton, 'enable', 'off');
set(handles.contButton, 'enable', 'off');

set(handles.npBox,'enable', 'inactive');
set(handles.sfBox,'enable', 'inactive');
set(handles.swBox,'enable', 'inactive');
set(handles.pulseBox,'enable', 'inactive');
set(handles.transBox,'enable', 'inactive');
set(handles.repdelayBox,'enable', 'inactive');
set(handles.numscansBox,'enable', 'inactive');
set(handles.txphaseBox,'enable', 'inactive');
set(handles.filenameBox,'enable', 'off');
set(handles.adcBox,'enable', 'inactive');
set(handles.ampBox,'enable', 'inactive');
set(handles.firCheck,'enable','inactive');
set(handles.cyclopsCheck,'enable','inactive');
set(handles.radioHard,'enable','inactive');
set(handles.radioSinc,'enable','inactive');

if continuousFlag == 0

%This section of code occurs before the continuous scanning actually
%begins.  It ensures that the user at least has an initial set of
%acceptable values entered.

    [num_points, SF, SW, pulse_time, trans_time, repetition_delay, num_scans,...
        tx_phase, fname, bypass_fir, adc_freq, amp_val, shape, num_Boards, ...
        blanking_bit, blanking_delay, run_Cyclops] = pollInputParameters(handles);
    
    

    errorFlag = errorCheckParameters(num_points, SF, SW, pulse_time, ...
                    trans_time, repetition_delay, num_scans, tx_phase, ...
                    adc_freq, amp_val, shape, blanking_bit, blanking_delay,...
                    run_Cyclops);
                
    continuousFlag = 1;
    
    setappdata(hCyclopsGui, 'continuousFlag', continuousFlag);
    
    set(handles.statusBox, 'string', 'Checking input parameters');
    pos = get(handles.progressBack,'Position');
    
% If invalid parameters have been entered, return from function.
    if errorFlag == 1
        set(handles.scanButton,'enable','on');
        set(handles.dataButton,'enable','on');
        set(handles.resButton,'enable','on');
        set(handles.contButton,'enable','on');      

        set(handles.npBox,'enable', 'on');
        set(handles.sfBox,'enable', 'on');
        set(handles.swBox,'enable', 'on');
        set(handles.pulseBox,'enable', 'on');
        set(handles.transBox,'enable', 'on');
        set(handles.repdelayBox,'enable', 'on');
        set(handles.numscansBox,'enable', 'on');
        set(handles.txphaseBox,'enable', 'on');
        set(handles.filenameBox,'enable', 'on');
        set(handles.adcBox,'enable', 'on');
        set(handles.ampBox,'enable', 'on');
        set(handles.firCheck,'enable','on');
        set(handles.radioHard,'enable','on');
        set(handles.radioSinc,'enable','on');
        set(handles.cyclopsCheck,'enable','on');
        set(handles.statusBox, 'Scan failed');
        drawnow;
        return;
     
% If all parameters are valid, save parameters and begin continuous scan        
    
    elseif errorFlag == 0
        
        set(handles.progressBar,'Position', [pos(1)+0.002 pos(2)+0.002 pos(3)-0.002 pos(4)-0.002]);
        set(handles.progressBar,'string','Scanning continuously.');
        set(handles.statusBox,'string','Scanning continuously.');
        drawnow;
        
        storeInputParameters(num_points, SF, SW, pulse_time, trans_time, ...
                repetition_delay, num_scans, tx_phase, fname, bypass_fir, adc_freq, ...
                amp_val, shape, blanking_bit, blanking_delay, run_Cyclops);
        
        setappdata(hCyclopsGui, 'continuousFlag', 1);
          
        tic;
        
        continuousFlag = getappdata(hCyclopsGui, 'continuousFlag');
        tmp_rep_delay = repetition_delay;
        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Begin continuous scan loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        disp('Beginning Continuous Scan...');
        while continuousFlag == 1

            t = toc;

            if (num_scans == 1 && t < repetition_delay)
                tmp_rep_delay = repetition_delay - t;
            elseif (num_scans == 1 && t > repetition_delay)
                tmp_rep_delay = 0.001;
            end

            SpnmrWithDelay(num_points, SF, SW, pulse_time, trans_time, tmp_rep_delay,...
                num_scans, tx_phase, bypass_fir, adc_freq, amp_val, blanking_bit,...
                blanking_delay, shape);
        
% Download the data from the radioprocessor and plot output
            tic;

            [realData,imagData] = pbGetData();

            realData=double(realData(1:num_points));
            imagData=double(imagData(1:num_points));

            dataFlag = 1;

            timeValues = (1:num_points)*(1/SW);

            magData = zeros(1,num_points);

            n = 1:num_points;
            magData(n) = sqrt(realData(n).^2+imagData(n).^2);

            [compPsd,freqValues] = generatePsd(num_points, SW, realData, imagData);
            
            switch get(handles.timePanel,'SelectedObject')
                case handles.radioReal
                    axes(handles.axes1);
                    plotRealData(timeValues,realData);
                case handles.radioImag
                    axes(handles.axes1);
                    plotImagData(timeValues,imagData);
                case handles.radioMag
                    axes(handles.axes1);
                    plotMagData(timeValues,magData);
            end

            switch get(handles.freqPanel,'SelectedObject')
                case handles.radioSemi
                    axes(handles.axes2);
                    semilogCompPsd(freqValues,compPsd);
                case handles.radioLinear
                    axes(handles.axes2);
                    plotCompPsd(freqValues,compPsd);
            end

            continuousFlag = getappdata(hCyclopsGui, 'continuousFlag');
        end    

    set(handles.statusBox,'String','Continuous scan stopped.');
    set(handles.progressBar,'Position', [pos(1)+0.002 pos(2)+0.002 pos(3)-0.002 pos(4)-0.002]);
    set(handles.progressBar,'string','Continuous scan stopped.');
    set(handles.scanButton,'enable','on');
    set(handles.dataButton,'enable','on');
    set(handles.resButton,'enable','on');
    set(handles.contButton,'enable','on');
    
    setappdata(hCyclopsGui, 'dataFlag', dataFlag);
    
    set(handles.npBox,'enable', 'on');
    set(handles.sfBox,'enable', 'on');
    set(handles.swBox,'enable', 'on');
    set(handles.pulseBox,'enable', 'on');
    set(handles.transBox,'enable', 'on');
    set(handles.repdelayBox,'enable', 'on');
    set(handles.numscansBox,'enable', 'on');
    set(handles.txphaseBox,'enable', 'on');
    set(handles.filenameBox,'enable', 'on');
    set(handles.adcBox,'enable', 'on');
    set(handles.ampBox,'enable', 'on');
    set(handles.firCheck,'enable', 'on');
    end
    
end



%% Stop Scan Button Callback
% --- Executes on button press in stopButton.
function stopButton_Callback(hObject, eventdata, handles)
% hObject    handle to stopButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hCyclopsGui = getappdata(0, 'hCyclopsGui');

pbStop();

continuousFlag = getappdata(hCyclopsGui, 'continuousFlag');

if continuousFlag == 1
    set(handles.statusBox, 'string', 'Stopping scan...');
    setappdata(hCyclopsGui, 'continuousFlag', 0);
    return;
end
set([handles.boardNum handles.npBox handles.sfBox handles.swBox handles.pulseBox handles.transBox ...
    handles.repdelayBox handles.numscansBox handles.txphaseBox handles.adcBox handles.ampBox ...
    handles.filenameBox handles.blankbitBox handles. blankdlyBox handles.firCheck handles.cyclopsCheck ...
    handles.scanButton handles.dataButton handles.resButton handles.contButton],'enable','on');
%set(handles.statusBox,'string','Scan stopped.');
set(handles.progressBar,'string','Scan stopped.');
set(handles.stopButton,'enable','off');
drawnow;



%% Set to Resonance Button Callback
% --- Executes on button press in resButton.
function resButton_Callback(hObject, eventdata, handles)
% hObject    handle to resButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.scanButton,'enable','off');
set(handles.dataButton,'enable','off');
set(handles.contButton,'enable','off');
set(handles.stopButton,'enable','off');
set(handles.snrButton,'enable','off');
set(handles.buttonNewPlot1,'enable','off');
set(handles.buttonNewPlot2,'enable','off');

errorFlag = 0;

[num_points, SF, SW, pulse_time, trans_time, repetition_delay, num_scans, ...
    tx_phase, fname, bypass_fir, adc_freq, amp_val, shape,num_Boards, ...
    blanking_bit, blanking_delay, run_Cyclops] = pollInputParameters(handles);

errorFlag = errorCheckParameters(num_points, SF, SW, pulse_time, ...
                trans_time, repetition_delay, num_scans, tx_phase, ...
                adc_freq, amp_val, shape, blanking_bit, blanking_delay, run_Cyclops);  

if errorFlag == 0

    %set(handles.statusBox,'String','Detecting Resonance Frequency');
    drawnow;
    
    storeInputParameters(num_points, SF, SW, pulse_time, trans_time, ...
            repetition_delay, num_scans, tx_phase, fname, bypass_fir, adc_freq, ...
            amp_val, shape, blanking_bit, blanking_delay, run_Cyclops);

    disp('Beginning Set-to-resonance Scan...');
    SpnmrWithDelay(num_points, SF, SW, pulse_time, trans_time, repetition_delay,...
        num_scans, tx_phase, bypass_fir, adc_freq, amp_val, blanking_bit, ...
        blanking_delay, shape);  

    [realRes, imagRes] = pbGetData();
    realRes = double(realRes);
    imagRes = double(imagRes);
    
    compRes = zeros(1,num_points);
    pos = get(handles.progressBack,'Position');
    for n = 1:num_points
        compRes(n) = realRes(n)+i*imagRes(n);
    end
    
    compResFft = fft(compRes);
    [maxVal,index] = max(compResFft);
    if index > num_points/2
        offset = -1*(num_points-index+1)*SW*(1/num_points)*(1/1000);
    else
        offset = SW*(index-1)*(1/num_points)*(1/1000);
    end
    
    if index > num_points/2
        resSF = SF + offset;
    else
        resSF = SF + offset;
    end
        
    set(handles.sfBox,'String',resSF);
    
    set(handles.dataButton,'enable','on');
    
    set(handles.dataButton,'enable','on');
    
    set(handles.progressBar,'Position',[pos(1)+0.002 pos(2)+0.002 pos(3)-0.004 pos(4)-0.004]);
    set(handles.progressBar,'string','Ready');
    drawnow;
    
end

set(handles.scanButton,'enable','on');
set(handles.contButton,'enable','on');
set(handles.stopButton,'enable','on');
set(handles.buttonNewPlot1,'enable','on');
set(handles.buttonNewPlot2,'enable','on');



%% Calculate SNR Button Callback
% --- Executes on button press in snrButton.
function snrButton_Callback(hObject, eventdata, handles)
% hObject    handle to snrButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hParentGui = gcf;
hCyclopsGui = getappdata(0, 'hCyclopsGui');
setappdata(0, 'hParentGui', hParentGui);
setappdata(hParentGui, 'freqValues', getappdata(hCyclopsGui,'freqValues'));
setappdata(hParentGui, 'compPsd', getappdata(hCyclopsGui,'compPsd'));

spincore_snr_gui;



%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% These functions below serve as macros created to eliminate large sections
% of code and to ease future development and/or changes.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Poll Input Parameters Function
function [num_points, SF, SW, pulse_time, trans_time, repetition_delay, num_scans, ...
    tx_phase, fname, bypass_fir, adc_freq, amp_val, shape, num_Boards, ...
    blanking_bit, blanking_delay, run_Cyclops]= pollInputParameters(handles)
    
    num_points = str2double(get(handles.npBox,'String'));
    SF = str2double(get(handles.sfBox,'String'));
    SW = str2double(get(handles.swBox,'String'));
    pulse_time = str2double(get(handles.pulseBox,'String'));
    trans_time = str2double(get(handles.transBox,'String'));
    repetition_delay = str2double(get(handles.repdelayBox,'String'));
    num_scans = str2double(get(handles.numscansBox,'String'));
    tx_phase = str2double(get(handles.txphaseBox,'String'));
    fname = get(handles.filenameBox,'String');
    adc_freq = str2double(get(handles.adcBox,'String'));
    amp_val = str2double(get(handles.ampBox,'String'));
    
    num_Boards = str2double(get(handles.boardNum,'String'));
    blanking_bit = str2double(get(handles.blankbitBox,'String'));
    blanking_delay = str2double(get(handles.blankdlyBox,'String'));
    
    if (get(handles.firCheck,'Value') == get(handles.firCheck,'Max'))
        % Checkbox is checked
        bypass_fir = 1;
    else
        % Checkbox is not checked
        bypass_fir = 0;
    end

    switch get(handles.panelPulse,'SelectedObject')
        case handles.radioHard
            shape = 'Hard';
        case handles.radioSinc
            shape = 'Sinc';
    end
     if(get(handles.cyclopsCheck,'Value') == get(handles.cyclopsCheck, 'Max'))
         run_Cyclops = 1;
     else
         run_Cyclops = 0;
     end
    
    
%% Store Input Parameters Function
function storeInputParameters(num_points, SF, SW, pulse_time, trans_time, ...
            repetition_delay, num_scans, tx_phase, fname, bypass_fir, adc_freq, ...
            amp_val, shape, blanking_bit, blanking_delay, run_Cyclops)

hCyclopsGui = getappdata(0, 'hCyclopsGui');

setappdata(hCyclopsGui, 'num_points', num_points);
setappdata(hCyclopsGui, 'SF', SF);
setappdata(hCyclopsGui, 'SW', SW);
setappdata(hCyclopsGui, 'pulse_time', pulse_time);
setappdata(hCyclopsGui, 'trans_time', trans_time);
setappdata(hCyclopsGui, 'repetition_delay', repetition_delay);
setappdata(hCyclopsGui, 'num_scans', num_scans);
setappdata(hCyclopsGui, 'tx_phase', tx_phase);
setappdata(hCyclopsGui, 'fname', fname);
setappdata(hCyclopsGui, 'adc_freq', adc_freq);
setappdata(hCyclopsGui, 'amp_val', amp_val);
setappdata(hCyclopsGui, 'bypass_fir', bypass_fir);
setappdata(hCyclopsGui, 'shape', shape);
setappdata(hCyclopsGui, 'blanking_bit', blanking_bit);
setappdata(hCyclopsGui, 'blanking_delay', blanking_delay);
setappdata(hCyclopsGui, 'run_Cyclops', run_Cyclops);


%% Error Check Parameters Function
% This function accepts all the scan input parameters and checks whether or
% not they are acceptable values.  If an error occurs, the output value
% errorFlag is set to 1.  Otherwise, errorFlag is returned as 0.
function errorFlag = errorCheckParameters(num_points, SF, SW, pulse_time, ...
                        trans_time, repetition_delay, num_scans, tx_phase, ...
                        adc_freq, amp_val, shape, blanking_bit, blanking_delay, run_Cyclops)


errorFlag = 0;
if (num_points < 1 || num_points > 16384 || isnan(num_points) || mod(num_points,2) == 1)
    errordlg('Number of points must be an even integer between 2 and 16384.');
    errorFlag = 1;
elseif (SF < 0 || isnan(SF))
    errordlg('Spectrometer frequency must be a number greater than or equal to 0');
    errorFlag = 1;
elseif (SW < 0 || isnan(SW))
    errordlg('Spectral width must be a number greater than or equal to 0');
    errorFlag = 1;
elseif (pulse_time < 0.065 || isnan(pulse_time) || (pulse_time > 100 && strcmp(shape,'Hard')))
    errordlg('For hard pulses, pulse time must be a number between 0.065 and 100');
    errorFlag = 1;
elseif (pulse_time < 0.065 || isnan(pulse_time) || (pulse_time > 10000 && strcmp(shape,'Sinc')))
    errordlg('For sinc pulses, pulse time must be a number between 0.065 and 10000');
    errorFlag = 1;
elseif (trans_time < 0.065 || isnan(trans_time))
    errordlg('Ringdown time must be a number greater than or equal to 0.065');
    errorFlag = 1;
elseif (repetition_delay < 0 || isnan(repetition_delay))
    errordlg('Repetition delay must be a number greater than or equal to 0');
    errorFlag = 1;
elseif (num_scans < 1 || isnan(num_scans))
    errordlg('At least one scan must be performed.');
    errorFlag = 1;
elseif (num_scans >1 && run_Cyclops == 1 && rem(num_scans,4)~=0)
%elseif (num_scans >1 && rem(num_scans,4)~=0)
    str = sprintf('Please check the Number of Scans. \nTo run CYCLOPS, the Number of Scans must be a multiple of 4.');
     msgbox(str,'Error','warn');
     errorFlag = 1;
elseif (tx_phase < 0 || tx_phase > 360 || isnan(tx_phase))
    errordlg('Output phase must be between 0 and 360 degrees');
    errorFlag = 1;
elseif (adc_freq < 0 || isnan(adc_freq))
    errordlg('Please enter correct clock time for your board (75 MHz unless specified otherwise');
    errorFlag = 1;
elseif (amp_val < 0 || amp_val > 1 || isnan(amp_val))
    errordlg('Amplitude must be a value between 0 and 1.');
    errorFlag = 1;
elseif (blanking_bit < 0 || blanking_bit > 7 || isnan(blanking_bit))
    errordlg('Blanking bit must be between 0 and 7');
    errorFlag = 1;
elseif (blanking_delay < 1.0 || blanking_delay > 5000.0 || isnan(blanking_delay))
    errordlg('Blanking delay must be between 1.0 us and 5.0 ms');
    errorFlag = 1;
end  


%% Generated PSD Function
function [compPsd,freqValues] = generatePsd(num_points, SW, realData, imagData)

compPsd=zeros(1,num_points);
compPsd2=zeros(1,num_points);
comp=zeros(1,num_points);

n = 1:num_points;
comp(n) = realData(n)+i*imagData(n);
freqValues = -1*SW*((num_points/2)+1-n)/num_points;

compFft = fft(comp, num_points);

compPsd=compFft.*conj(compFft)/num_points;   

compPsd2(1:(num_points/2))=compPsd((num_points/2)+1:num_points);
compPsd2((num_points/2)+1:(num_points))=compPsd(1:(num_points/2));

compPsd=compPsd2;



%% Plotting Functions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Plotting Functions - these functions accept data and return the plots in
% a specific format.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function plotRealData(timeValues,realData)

plot(timeValues,realData);
xlabel('Time (milliseconds)');
ylabel('Amplitude');
title('Time Domain - Real Data');
axis tight;
drawnow;

function plotImagData(timeValues,imagData)

plot(timeValues,imagData);
xlabel('Time (milliseconds)');
ylabel('Amplitude');
title('Time Domain - Imaginary Data');
axis tight;
drawnow;

function plotMagData(timeValues,magData)

plot(timeValues,magData);
xlabel('Time (milliseconds)');
ylabel('Amplitude');
title('Time Domain - Magnitude Data');
axis tight;
drawnow;

function plotCompPsd(freqValues,compPsd)

plot(freqValues,compPsd);
set(gca, 'XDir', 'reverse');
xlabel('Frequency (kHz)');
ylabel('Amplitude');
title('Power Spectral Density, Linear Scale');
drawnow;

function semilogCompPsd(freqValues,compPsd)

semilogy(freqValues,compPsd);
set(gca, 'XDir', 'reverse');
xlabel('Frequency (kHz)');
ylabel('Amplitude');
title('Power Spectral Density, Semi-Log Scale');
axis tight;
drawnow;    


%% Timer Function
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% TIMER interrupt is used to check the status of the experiment
% Updates the current status of the experiment running on the board
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function timer_function(src,event, handles)
    handles = guidata(handles); % <- retrieve the updated one
    hCyclopsGui = getappdata(0, 'hCyclopsGui');
    num_scans = getappdata(hCyclopsGui, 'num_scans');
    [pbstatus, pbscans] = pbReadStatus();
    pbstatus=double(pbstatus);
    pbscans=double(pbscans);
    if (pbstatus < 0 || isnan(pbstatus))
        pbstatus = 0;
    end
    if (pbscans < 0 || isnan(pbscans))
         pbscans = 0;
    end
%Indicate to the user how many scans have been completed
pos = get(handles.progressBack,'Position');
if bitget(pbstatus, 3) == 1
    PerComplete = sprintf('%d',round(100*pbscans/num_scans));
    p3=(pos(3)-0.004)*pbscans/num_scans;
    if p3==0 p3=0.001; end
    set(handles.progressBar,'Position',[pos(1)+0.002 pos(2)+0.002 p3 pos(4)-0.004 ]);
    set(handles.progressBar,'String', [PerComplete '%']);
    drawnow;
else
    disp('Completed');
    set(handles.progressBar,'Position',[pos(1)+0.002 pos(2)+0.002 pos(3)-0.004 pos(4)-0.004]);
    set(handles.progressBar,'String', 'Completed');
    set([handles.boardNum handles.npBox handles.sfBox handles.swBox handles.pulseBox handles.transBox ...
        handles.repdelayBox handles.numscansBox handles.txphaseBox handles.adcBox handles.ampBox ...
        handles.filenameBox handles.blankbitBox handles.blankdlyBox handles.firCheck handles.cyclopsCheck],'enable','on');
        stop(handles.timer);
    drawnow;
end
    guidata(handles.guifig,handles);
    

    
      
%% Close GUI Function
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Executes when the GUI is closing to confirm 
% Also clean up timer interrupt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function checkCloseGUI(src,event,handles)
selection = questdlg('Do you really want to exit the program?',...
                     'Close Request Function',...
                     'Yes','No','Yes');
switch selection,
   case 'Yes',
    delete(handles.timer)   %This must be called to kill timer process
    delete(gcf)
   case 'No'
     return
end



%% Create Functions
    

% --- Executes during object creation, after setting all properties.
function boardNum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to boardNum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function npBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to npBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function sfBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sfBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function swBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to swBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function pulseBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pulseBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function transBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to transBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function repdelayBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to repdelayBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function numscansBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numscansBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function txphaseBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txphaseBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function adcBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to adcBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function ampBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ampBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function filenameBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to filenameBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function blankbitBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to blankbitBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function blankdlyBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to blankdlyBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function progressBack_Callback(hObject, eventdata, handles)
% hObject    handle to progressBack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of progressBack as text
%        str2double(get(hObject,'String')) returns contents of progressBack as a double


% --- Executes during object creation, after setting all properties.
function progressBack_CreateFcn(hObject, eventdata, handles)
% hObject    handle to progressBack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in progressBar.
function progressBar_Callback(hObject, eventdata, handles)
% hObject    handle to progressBar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function statusBox_Callback(hObject, eventdata, handles)
% hObject    handle to statusBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of statusBox as text
%        str2double(get(hObject,'String')) returns contents of statusBox as a double


% --- Executes during object creation, after setting all properties.
function statusBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to statusBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% The END



